/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Contents of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph


Revision 1.163 - (show annotations) (download)
Fri May 25 14:56:36 2007 UTC (16 years, 9 months ago) by mlosch
Branch: MAIN
CVS Tags: checkpoint59e, checkpoint59d, checkpoint59c
Changes since 1.162: +4 -2 lines
improve output to genmake_warnings

1 #! /usr/bin/env bash
2 #
3 # $Header: /u/gcmpack/MITgcm/tools/genmake2,v 1.162 2007/05/05 20:18:52 jmc Exp $
4 #
5 # Makefile generator for MITgcm UV codes
6 # created by cnh 03/98
7 # adapted by aja 06/98
8 # modified by aja 01/00
9 # rewritten in bash by eh3 08/03
10
11 # Search for particular CPP #cmds associated with packages
12 # usage: test_for_package_in_cpp_options CPP_file package_name
13 test_for_package_in_cpp_options() {
14 cpp_options=$1
15 pkg=$2
16 test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg[ ]"
17 test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg[ ]"
18 test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg[ ]"
19 test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg[ ]"
20 test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg$"
21 test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg$"
22 test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg$"
23 test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg$"
24 }
25
26 # Search for particular CPP #cmds associated with MPI
27 # usage: test_for_mpi_in_cpp_eeoptions CPP_file
28 test_for_mpi_in_cpp_eeoptions() {
29 cpp_options=$1
30 test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI[ ]"
31 test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI[ ]"
32 test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI[ ]"
33 test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI[ ]"
34 test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI$"
35 test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI$"
36 test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI$"
37 test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI$"
38 }
39
40 # Search for particular string in a file. Return 1 if detected, 0 if not
41 # usage: test_for_string_in_file file string
42 test_for_string_in_file() {
43 file=$1
44 strng=$2
45 grep -i "$strng" $file > /dev/null 2>&1
46 RETVAL=$?
47 if test "x${RETVAL}" = x0 ; then
48 printf "Error: In $file there is an illegal line: "
49 grep -i "$strng" $file
50 exit 99
51 fi
52 return 0
53 }
54
55 # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to
56 # the package list.
57 expand_pkg_groups() {
58 new_packages=
59 PKG_GROUPS=$ROOTDIR"/pkg/pkg_groups"
60 if test -r $PKG_GROUPS ; then
61 cat $PKG_GROUPS | sed -e 's/#.*$//g' | sed -e 's/:/ : /g' > ./p1.tmp
62 cat ./p1.tmp | $AWK '(NF>2 && $2==":"){ print $0 }' > ./p2.tmp
63 matched=0
64 for i in $PACKAGES ; do
65 line=`grep "^ *$i" ./p2.tmp`
66 RETVAL=$?
67 if test "x$RETVAL" = x0 ; then
68 matched=1
69 replace=`echo $line | $AWK '{ $1=""; $2=""; print $0 }'`
70 echo " replacing \"$i\" with: $replace"
71 new_packages="$new_packages $replace"
72 else
73 new_packages="$new_packages $i"
74 fi
75 done
76 PACKAGES=$new_packages
77 rm -f ./p[1,2].tmp
78 return $matched
79 else
80 echo "Warning: can't read package groups definition file: $PKG_GROUPS"
81 fi
82 }
83
84 # Check for broken environments (eg. cygwin, MacOSX w/HFS+) that
85 # cannot distinguish [*.F/*.F90] from [*.f/*.f90] files.
86 check_for_broken_Ff() {
87 # Do we have defaults for $FS and/or $FS90 ?
88 tfs=f
89 tfs9=f90
90 if test "x$FS" != x ; then
91 tfs="$FS"
92 fi
93 if test "x$FS90" != x ; then
94 tfs9="$FS90"
95 fi
96
97 # First check the ability to create a *.F/.f pair.
98 cat <<EOF >> genmake_hello.F
99 program hello
100 write(*,*) 'hi'
101 stop
102 end
103 EOF
104 cp genmake_hello.F "genmake_hello."$tfs > /dev/null 2>&1
105 RETVAL=$?
106 if test "x$RETVAL" != x0 ; then
107 if test "x$FS" = x ; then
108 FS='for'
109 FS90='fr9'
110 check_for_broken_Ff
111 else
112 cat <<EOF 2>&1
113 ERROR: Your file system cannot distinguish between *.F and *.f files
114 (fails the "cp" test) and this program cannot find a suitable
115 replacement extension. Please try a different build environment or
116 contact the <MITgcm-support@mitgcm.org> list for help.
117
118 EOF
119 exit -1
120 fi
121 return
122 fi
123 rm -f genmake_hello.*
124
125 # Check the ability of ${MAKE} and ${LN} to use the current set
126 # of extensions.
127 cat <<EOF >> genmake_hello.F
128 program hello
129 write(*,*) 'hi'
130 stop
131 end
132 EOF
133 test -f $MAKEFILE && mv -f $MAKEFILE $MAKEFILE".tst"
134 cat <<EOF >> $MAKEFILE
135 .SUFFIXES:
136 .SUFFIXES: .$tfs .F
137 .F.$tfs:
138 $LN \$< \$@
139 EOF
140 $MAKE "genmake_hello."$tfs > /dev/null 2>&1
141 RETVAL=$?
142 if test "x$RETVAL" != x0 -o ! -f "genmake_hello."$tfs ; then
143 if test "x$FS" = x ; then
144 FS='for'
145 FS90='fr9'
146 check_for_broken_Ff
147 else
148 cat <<EOF 2>&1
149 ERROR: Your file system cannot distinguish between *.F and *.f files
150 (fails the "make/ln" test) and this program cannot find a suitable
151 replacement extension. Please try a different build environment or
152 contact the <MITgcm-support@mitgcm.org> list for help.
153
154 EOF
155 exit -1
156 return
157 fi
158 fi
159 rm -f genmake_hello.* $MAKEFILE
160 test -f $MAKEFILE".tst" && mv -f $MAKEFILE".tst" $MAKEFILE
161
162 # If we make it here, use the extensions
163 FS=$tfs
164 FS90=$tfs9
165 return
166 }
167
168
169 look_for_makedepend() {
170
171 # The "original" makedepend is part of the Imake system that is
172 # most often distributed with XFree86 or with an XFree86 source
173 # package. As a result, many machines (eg. generic Linux) do not
174 # have a system-default "makedepend" available. For those
175 # systems, we have two fall-back options:
176 #
177 # 1) a makedepend implementation shipped with the cyrus-imapd
178 # package: ftp://ftp.andrew.cmu.edu/pub/cyrus-mail/
179 #
180 # 2) a known-buggy xmakedpend shell script
181 #
182 # So the choices are, in order:
183 #
184 # 1) use the user-specified program
185 # 2) use a system-wide default
186 # 3) locally build and use the cyrus implementation
187 # 4) fall back to the buggy local xmakedpend script
188 #
189 if test "x${MAKEDEPEND}" = x ; then
190 which makedepend > /dev/null 2>&1
191 RV0=$?
192 test -f $MAKEFILE && mv -f $MAKEFILE $MAKEFILE".tst"
193 # echo 'MAKEFILE="'$MAKEFILE'"'
194 cat <<EOF >> $MAKEFILE
195 # THIS IS A TEST MAKEFILE GENERATED BY "genmake2"
196 #
197 # Some "makedepend" implementations will die if they cannot
198 # find a Makefile -- so this file is here to gives them an
199 # empty one to find and parse.
200 EOF
201 cat <<EOF >> genmake_tc.f
202 program test
203 write(*,*) 'test'
204 stop
205 end
206 EOF
207 makedepend genmake_tc.f > /dev/null 2>&1
208 RV1=$?
209 test -f $MAKEFILE && rm -f $MAKEFILE
210 test -f $MAKEFILE".tst" && mv -f $MAKEFILE".tst" $MAKEFILE
211 if test "x${RV0}${RV1}" = x00 ; then
212 MAKEDEPEND=makedepend
213 else
214 echo " a system-default makedepend was not found."
215
216 # Try to build the cyrus implementation
217 build_cyrus_makedepend
218 RETVAL=$?
219 if test "x$RETVAL" != x0 ; then
220 MAKEDEPEND='$(TOOLSDIR)/xmakedepend'
221 fi
222 rm -f ./genmake_cy_md
223 fi
224 else
225 # echo "MAKEDEPEND=${MAKEDEPEND}"
226 echo "${MAKEDEPEND}" | grep -i cyrus > /dev/null 2>&1
227 RETVAL=$?
228 if test x"$RETVAL" = x0 ; then
229 build_cyrus_makedepend
230 fi
231 fi
232 }
233
234
235 build_cyrus_makedepend() {
236 rm -f ./genmake_cy_md
237 (
238 cd $ROOTDIR/tools/cyrus-imapd-makedepend \
239 && ./configure > /dev/null 2>&1 \
240 && make > /dev/null 2>&1
241 if test -x ./makedepend.exe ; then
242 $LN ./makedepend.exe ./makedepend
243 fi
244 ./makedepend ifparser.c > /dev/null 2>&1 \
245 && echo "true"
246 ) > ./genmake_cy_md
247 grep true ./genmake_cy_md > /dev/null 2>&1
248 RETVAL=$?
249 rm -f ./genmake_cy_md
250 if test "x$RETVAL" = x0 ; then
251 MAKEDEPEND='$(TOOLSDIR)/cyrus-imapd-makedepend/makedepend'
252 return 0
253 else
254 echo "WARNING: unable to build cyrus-imapd-makedepend"
255 return 1
256 fi
257 }
258
259
260 build_embed_encode()
261 {
262 printf " building the embed-encode utility... "
263 if test ! -e "$ROOTDIR/tools/embed_encode/encode_files" ; then
264 if test ! -d "$ROOTDIR/tools/embed_encode" ; then
265 echo
266 echo " Error: can't locate \"$ROOTDIR/tools/embed_encode\""
267 echo
268 EMBED_SRC=f
269 return 1
270 fi
271 clist="cc gcc c89 $CC"
272 for ic in $clist ; do
273 comm="$ic -o encode_files encode_files.c"
274 ( cd $ROOTDIR/tools/embed_encode && $comm ) > /dev/null 2>&1
275 RETVAL=$?
276 if test "x$RETVAL" = x0 ; then
277 echo "OK"
278 DEFINES="$DEFINES -DHAVE_EMBED_SRC"
279 return 0
280 fi
281 done
282 echo
283 echo " Error: unable to build $ROOTDIR/embed_encode/encode_files"
284 echo " so it has been disabled"
285 echo
286 EMBED_SRC=f
287 return 1
288 fi
289 echo "OK"
290 DEFINES="$DEFINES -DHAVE_EMBED_SRC"
291 }
292
293
294 # Guess possible config options for this host
295 find_possible_configs() {
296
297 tmp1=`uname`"_"`uname -m`
298 tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
299 tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
300 tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`
301 tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
302 tmp3=`echo $tmp2 | sed -e 's/cray sv1/craysv1/'`
303 PLATFORM=$tmp3
304 echo $PLATFORM | grep cygwin > /dev/null 2>&1 && PLATFORM=cygwin_ia32
305 OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
306 echo " The platform appears to be: $PLATFORM"
307
308 echo "test" > test
309 ln -s ./test link
310 RETVAL=$?
311 if test "x${RETVAL}" = x0 ; then
312 LN="ln -s"
313 else
314 echo "Error: \"ln -s\" does not appear to work on this system!"
315 echo " For help, please contact <MITgcm-support@mitgcm.org>."
316 exit 1
317 fi
318 rm -f test link
319
320 if test "x$CPP" = x ; then
321 CPP="cpp -traditional -P"
322 fi
323
324 look_for_makedepend
325
326 #================================================================
327 # look for possible C compilers
328 tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc icc"
329 p_CC=
330 for c in $tmp ; do
331 rm -f ./genmake_hello.c ./genmake_hello
332 cat >> genmake_hello.c << EOF
333 #include <stdio.h>
334 int main(int argc, char **argv) {
335 printf("Hello!\n");
336 return 0;
337 }
338 EOF
339 $c -o genmake_hello genmake_hello.c > /dev/null 2>&1
340 RETVAL=$?
341 if test "x${RETVAL}" = x0 ; then
342 p_CC="$p_CC $c"
343 fi
344 done
345 rm -f ./genmake_hello.c ./genmake_hello
346 if test "x${p_CC}" = x ; then
347 cat 1>&2 <<EOF
348
349 Error: No C compilers were found in your path. Please specify one using:
350
351 1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
352 2) the CC or MITGCM_CC environment variables.
353
354 EOF
355 exit 1
356 else
357 echo " The possible C compilers found in your path are:"
358 echo " "$p_CC
359 if test "x$CC" = x ; then
360 CC=`echo $p_CC | $AWK '{print $1}'`
361 echo " Setting C compiler to: "$CC
362 fi
363 fi
364
365 #================================================================
366 # look for possible FORTRAN compilers
367 tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc ifort f90 f95 mpif77 mpf77 mpxlf95 gfortran g95"
368 p_FC=
369 for c in $tmp ; do
370 rm -f ./hello.f ./hello
371 cat >> hello.f <<EOF
372 program hello
373 do i=1,3
374 print *, 'hello world : ', i
375 enddo
376 end
377 EOF
378 $c -o hello hello.f > /dev/null 2>&1
379 RETVAL=$?
380 if test "x${RETVAL}" = x0 ; then
381 p_FC="$p_FC $c"
382 fi
383 done
384 rm -f ./hello.f ./hello
385 if test "x${p_FC}" = x ; then
386 cat 1>&2 <<EOF
387
388 Error: No Fortran compilers were found in your path. Please specify one using:
389
390 1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
391 2) a command-line option (eg. "-fc NAME"), or
392 3) the FC or MITGCM_FC environment variables.
393
394 EOF
395 exit 1
396 else
397 echo " The possible FORTRAN compilers found in your path are:"
398 echo " "$p_FC
399 fi
400
401 # Use the first of the compilers found in the current PATH
402 # that has a correctly-named optfile
403 if test "x$OPTFILE" = x -a "x$FC" = x ; then
404 for i in $p_FC ; do
405 OPTFILE=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
406 if test -r $OPTFILE ; then
407 echo " Setting OPTFILE to: "$OPTFILE
408 break
409 fi
410 done
411 fi
412
413 if test "x$OPTFILE" = x ; then
414 OPTFILE=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$FC
415 if test ! -r $OPTFILE ; then
416 echo " I looked for the file "$OPTFILE" but did not find it"
417 fi
418 fi
419 # echo " The options file: $p_OF"
420 # echo " appears to match so we'll use it."
421 # for i in $p_FC ; do
422 #p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
423 #if test -r $p_OF ; then
424 # OPTFILE=$p_OF
425 # echo " The options file: $p_OF"
426 # echo " appears to match so we'll use it."
427 # break
428 #fi
429 # done
430 if test "x$OPTFILE" = x ; then
431 cat 1>&2 <<EOF
432
433 Error: No options file was found in: $ROOTDIR/tools/build_options/
434 that matches this platform ("$PLATFORM") and the compilers found in
435 your path. Please specify an "optfile" using:
436
437 1) the command line (eg. "-optfile=path/to/OPTFILE"), or
438 2) the MITGCM_OF environment variable.
439
440 If you need help, please contact the developers at <MITgcm-support@mitgcm.org>.
441
442 EOF
443 exit 1
444 fi
445
446 # # look for possible MPI libraries
447 # mpi_libs=
448 # mpi_fort=`which mpif77 2>/dev/null`
449 # RETVAL=$?
450 # if test "x${RETVAL}" = x0 ; then
451 # cat >>test.f <<EOF
452 # PROGRAM HELLO
453 # DO 10, I=1,10
454 # PRINT *,'Hello World'
455 # 10 CONTINUE
456 # STOP
457 # END
458 # EOF
459 # eval "$mpi_fort -showme test.f > out"
460 # RETVAL=$?
461 # if test "x${RETVAL}" = x0 ; then
462 # a=`cat out`
463 # for i in $a ; do
464 # case $i in
465 # -*)
466 # mpi_libs="$mpi_libs $i" ;;
467 # esac
468 # done
469 # echo "The MPI libs appear to be:"
470 # echo " "$mpi_libs
471 # fi
472 # rm -f test.f out
473 # fi
474
475 }
476
477 # Parse the package dependency information
478 get_pdepend_list() {
479
480 # strip the comments and then convert the dependency file into
481 # two arrays: PNAME, DNAME
482 cat $1 | sed -e 's/#.*$//g' \
483 | $AWK 'BEGIN{nn=0;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \
484 > ./.pd_tmp
485 . ./.pd_tmp
486 rm -f ./.pd_tmp
487
488 printf "PNAME = "${}
489 }
490
491
492 # Explain usage
493 usage() {
494 cat <<EOF
495
496 Usage: "$0" [OPTIONS]
497 where [OPTIONS] can be:
498
499 -help | --help | -h | --h
500 Print this help message and exit.
501
502 -adoptfile NAME | --adoptfile NAME | -adof NAME | --adof NAME
503 -adoptfile=NAME | --adoptfile=NAME | -adof=NAME | --adof=NAME
504 Use "NAME" as the adoptfile. By default, the file at
505 "tools/adjoint_options/adjoint_default" will be used.
506
507 -nooptfile | --nooptfile
508 -optfile NAME | --optfile NAME | -of NAME | --of NAME
509 -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME
510 Use "NAME" as the optfile. By default, an attempt will be
511 made to find an appropriate "standard" optfile in the
512 tools/build_options/ directory.
513
514 -pdepend NAME | --pdepend NAME
515 -pdepend=NAME | --pdepend=NAME
516 Get package dependency information from "NAME".
517
518 -pdefault NAME | --pdefault NAME
519 -pdefault=NAME | --pdefault=NAME
520 Get the default package list from "NAME".
521
522 -make NAME | -m NAME
523 --make=NAME | -m=NAME
524 Use "NAME" for the MAKE program. The default is "make" but
525 many platforms, "gmake" is the preferred choice.
526
527 -makefile NAME | -mf NAME
528 --makefile=NAME | -mf=NAME
529 Call the makefile "NAME". The default is "Makefile".
530
531 -makedepend NAME | -md NAME
532 --makedepend=NAME | -md=NAME
533 Use "NAME" for the MAKEDEPEND program.
534
535 -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME
536 -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME
537 Specify the location of the MITgcm ROOTDIR as "NAME".
538 By default, genamke will try to find the location by
539 looking in parent directories (up to the 5th parent).
540
541 -mods NAME | --mods NAME | -mo NAME | --mo NAME
542 -mods=NAME | --mods=NAME | -mo=NAME | --mo=NAME
543 Here, "NAME" specifies a list of directories that are
544 used for additional source code. Files found in the
545 "mods list" are given preference over files of the same
546 name found elsewhere.
547
548 -disable NAME | --disable NAME
549 -disable=NAME | --disable=NAME
550 Here "NAME" specifies a list of packages that we don't
551 want to use. If this violates package dependencies,
552 genamke will exit with an error message.
553
554 -enable NAME | --enable NAME
555 -enable=NAME | --enable=NAME
556 Here "NAME" specifies a list of packages that we wish
557 to specifically enable. If this violates package
558 dependencies, genamke will exit with an error message.
559
560 -standarddirs NAME | --standarddirs NAME
561 -standarddirs=NAME | --standarddirs=NAME
562 Here, "NAME" specifies a list of directories to be
563 used as the "standard" code.
564
565 -fortran NAME | --fortran NAME | -fc NAME | --fc NAME
566 -fc=NAME | --fc=NAME
567 Use "NAME" as the fortran compiler. By default, genmake
568 will search for a working compiler by trying a list of
569 "usual suspects" such as g77, f77, etc.
570
571 -cc NAME | --cc NAME | -cc=NAME | --cc=NAME
572 Use "NAME" as the C compiler. By default, genmake
573 will search for a working compiler by trying a list of
574 "usual suspects" such as gcc, c89, cc, etc.
575
576 -[no]ieee | --[no]ieee
577 Do or don't use IEEE numerics. Note that this option
578 *only* works if it is supported by the OPTFILE that
579 is being used.
580
581 -ignoretime | -ignore_time | --ignoretime | --ignore_time
582 Ignore all the "wall clock" routines entirely. This will
583 not in any way hurt the model results -- it simply means
584 that the code that checks how long the model spends in
585 various routines will give junk values.
586
587 -ts | --ts
588 Produce timing information per timestep
589 -papis | --papis
590 Produce summary MFlop/s (and IPC) with PAPI per timestep
591 -pcls | --pcls
592 Produce summary MFlop/s etc. with PCL per timestep
593 -foolad | --foolad
594 Fool the AD code generator
595 -papi | --papi
596 Performance analysis with PAPI
597 -pcl | --pcl
598 Performance analysis with PCL
599 -hpmt | --hpmt
600 Performance analysis with the HPM Toolkit
601
602 -gsl | --gsl
603 Use GSL to control floating point rounding and precision
604 -devel | --devel
605 Add additional warning and debugging flags for development
606
607 -mpi | --mpi
608 Include MPI header files and link to MPI libraries
609 -mpi=PATH | --mpi=PATH
610 Include MPI header files and link to MPI libraries using MPI_ROOT
611 set to PATH. i.e. Include files from \$PATH/include, link to libraries
612 from \$PATH/lib and use binaries from \$PATH/bin.
613
614 -es | --es | -embed-source | --embed-source
615 Embed a tarball containing the full source code
616 (including the Makefile, etc.) used to build the
617 executable [off by default]
618
619 -bash NAME
620 Explicitly specify the Bourne or BASH shell to use
621
622 While it is most often a single word, the "NAME" variables specified
623 above can in many cases be a space-delimited string such as:
624
625 --enable pkg1 --enable 'pkg1 pkg2' --enable 'pkg1 pkg2 pkg3'
626 -mods=dir1 -mods='dir1' -mods='dir1 dir2 dir3'
627 -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'
628
629 which, depending upon your shell, may need to be single-quoted.
630
631 For more detailed genmake documentation, please see:
632
633 http://mitgcm.org/devel_HOWTO/
634
635 EOF
636
637 exit 1
638 }
639
640 # Build a CPP macro to automate calling C routines from FORTRAN
641 get_fortran_c_namemangling() {
642
643 #echo "FC_NAMEMANGLE = \"$FC_NAMEMANGLE\""
644 if test ! "x$FC_NAMEMANGLE" = x ; then
645 return 0
646 fi
647
648 default_nm="#define FC_NAMEMANGLE(X) X ## _"
649
650 cat > genmake_test.c <<EOF
651 void tcall( char * string ) { tsub( string ); }
652 EOF
653 $MAKE genmake_test.o >> genmake_warnings 2>&1
654 RETVAL=$?
655 if test "x$RETVAL" != x0 ; then
656 FC_NAMEMANGLE=$default_nm
657 cat <<EOF>> genmake_errors
658
659 WARNING: C test compile fails
660 WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
661 WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here
662 EOF
663 return 1
664 fi
665 c_tcall=`nm genmake_test.o 2>/dev/null | grep 'T ' | grep tcall | cut -d ' ' -f 3`
666 RETVAL=$?
667 if test "x$RETVAL" != x0 ; then
668 FC_NAMEMANGLE=$default_nm
669 cat <<EOF>> genmake_warnings
670
671 WARNING: The "nm" command failed.
672 WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
673 WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here
674 EOF
675 return 1
676 fi
677 cat > genmake_tcomp.$FS <<EOF
678 subroutine tcall( string )
679 character*(*) string
680 call tsub( string )
681 end
682 EOF
683 $FC $FFLAGS -c genmake_tcomp.$FS >> genmake_warnings 2>&1
684 RETVAL=$?
685 if test "x$RETVAL" != x0 ; then
686 FC_NAMEMANGLE=$default_nm
687 cat <<EOF>> genmake_warnings
688
689 WARNING: FORTRAN test compile fails -- please see "genmake_errors"
690 WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
691 WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here.
692 EOF
693 return 1
694 fi
695 f_tcall=`nm genmake_tcomp.o 2>/dev/null | grep 'T ' | grep tcall | cut -d ' ' -f 3`
696 RETVAL=$?
697 if test "x$RETVAL" != x0 ; then
698 FC_NAMEMANGLE=$default_nm
699 cat <<EOF>> genmake_warnings
700
701 WARNING: The "nm" command failed.
702 WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
703 WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here.
704 EOF
705 return 1
706 fi
707
708 c_a=`echo $c_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 1 | sed -e 's|Y||'`
709 f_a=`echo $f_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 1 | sed -e 's|Y||'`
710 c_b=`echo $c_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 2 | sed -e 's|Y||'`
711 f_b=`echo $f_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 2 | sed -e 's|Y||'`
712
713 nmangle="X"
714 if test "x$c_a" != "x$f_a" ; then
715 comm="echo x$f_a | sed -e 's|x$c_a||'"
716 a=`eval $comm`
717 nmangle="$a ## $nmangle"
718 fi
719 if test "x$c_b" != "x$f_b" ; then
720 comm="echo x$f_b | sed -e 's|x$c_b||'"
721 b=`eval $comm`
722 nmangle="$nmangle ## $b"
723 fi
724
725 FC_NAMEMANGLE="#define FC_NAMEMANGLE(X) $nmangle"
726
727 # cleanup the testing files
728 rm -f genmake_tcomp.* genmake_test.*
729 }
730
731
732 check_HAVE_CLOC() {
733 get_fortran_c_namemangling
734 cat <<EOF > genmake_tc_1.c
735 $FC_NAMEMANGLE
736 #include <stdio.h>
737 #include <stdlib.h>
738 #include <unistd.h>
739 #include <assert.h>
740 #include <sys/time.h>
741 void FC_NAMEMANGLE(cloc) ( double *curtim )
742 {
743 struct timeval tv1;
744 gettimeofday(&tv1 , (void *)NULL );
745 *curtim = (double)((tv1.tv_usec)+(tv1.tv_sec)*1.E6);
746 *curtim = *curtim/1.E6;
747 }
748 EOF
749 make genmake_tc_1.o >> genmake_warnings 2>&1
750 RET_C=$?
751 cat <<EOF > genmake_tc_2.$FS
752 program hello
753 REAL*8 wtime
754 external cloc
755 call cloc(wtime)
756 print *," HELLO WORLD", wtime
757 end
758 EOF
759 COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
760 echo $COMM >> genmake_warnings
761 $COMM >> genmake_warnings 2>&1
762 RET_F=$?
763 test -x ./genmake_tc && ./genmake_tc >> genmake_warnings 2>&1
764 RETVAL=$?
765 if test "x$RETVAL" = x0 ; then
766 HAVE_CLOC=t
767 DEFINES="$DEFINES -DHAVE_CLOC"
768 fi
769 rm -f genmake_tc*
770 }
771
772
773 check_HAVE_SIGREG() {
774 if test ! "x$HAVE_SIGREG" = x ; then
775 return
776 fi
777 get_fortran_c_namemangling
778 cat <<EOF > genmake_tc_1.c
779 $FC_NAMEMANGLE
780 #include <stdlib.h>
781 #include <stdio.h>
782 #include <signal.h>
783 #include <errno.h>
784 #include <ucontext.h>
785
786 int * ip;
787
788 static void killhandler(
789 unsigned int sn, siginfo_t si, struct ucontext *sc )
790 {
791 *ip = *ip + 1;
792 return;
793 }
794
795 void FC_NAMEMANGLE(sigreg) (int * aip)
796 {
797 struct sigaction s;
798 ip = aip;
799 s.sa_flags = SA_SIGINFO;
800 s.sa_sigaction = (void *)killhandler;
801 if(sigaction (SIGTERM,&s,(struct sigaction *)NULL)) {
802 printf("Sigaction returned error = %d\n", errno);
803 exit(0);
804 }
805 return;
806 }
807 EOF
808 make genmake_tc_1.o >> genmake_warnings 2>&1
809 RET_C=$?
810 cat <<EOF > genmake_tc_2.$FS
811 program hello
812 integer anint
813 common /iv/ anint
814 external sigreg
815 call sigreg(anint)
816 end
817 EOF
818 echo >> genmake_warnings
819 echo "running: check_HAVE_SIGREG()" >> genmake_warnings
820 cat genmake_tc_2.$FS >> genmake_warnings
821 COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
822 echo $COMM >> genmake_warnings
823 $COMM >> genmake_warnings 2>&1
824 RETVAL=$?
825 if test "x$RETVAL" = x0 ; then
826 HAVE_SIGREG=t
827 DEFINES="$DEFINES -DHAVE_SIGREG"
828 fi
829 rm -f genmake_tc*
830 }
831
832
833 check_HAVE_SETRLSTK() {
834 if test "x$HAVE_SETRLSTK" = xt ; then
835 DEFINES="$DEFINES -DHAVE_SETRLSTK"
836 return
837 fi
838 if test ! "x$HAVE_SETRLSTK" = x ; then
839 return
840 fi
841 get_fortran_c_namemangling
842 cat <<EOF > genmake_tc_1.c
843 $FC_NAMEMANGLE
844 #include <sys/time.h>
845 #include <sys/resource.h>
846 #include <unistd.h>
847 void FC_NAMEMANGLE(setrlstk) ()
848 {
849 struct rlimit rls;
850 rls.rlim_cur = RLIM_INFINITY;
851 rls.rlim_max = RLIM_INFINITY;
852 setrlimit(RLIMIT_STACK, &rls);
853 return;
854 }
855 EOF
856 make genmake_tc_1.o >> genmake_warnings 2>&1
857 RET_C=$?
858 cat <<EOF > genmake_tc_2.$FS
859 program hello
860 external setrlstk
861 call setrlstk()
862 end
863 EOF
864 echo >> genmake_warnings
865 echo "running: check_HAVE_SETRLSTK()" >> genmake_warnings
866 cat genmake_tc_2.$FS >> genmake_warnings
867 COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
868 echo $COMM >> genmake_warnings
869 $COMM >> genmake_warnings 2>&1
870 RETVAL=$?
871 if test "x$RETVAL" = x0 ; then
872 HAVE_SETRLSTK=t
873 DEFINES="$DEFINES -DHAVE_SETRLSTK"
874 fi
875 rm -f genmake_tc*
876 }
877
878
879 check_HAVE_STAT() {
880 get_fortran_c_namemangling
881 cat <<EOF > genmake_tc_1.c
882 $FC_NAMEMANGLE
883 #include <stdio.h>
884 #include <stdlib.h>
885 #include <unistd.h>
886 #include <sys/stat.h>
887 #include <sys/types.h>
888 void FC_NAMEMANGLE(tfsize) ( int *nbyte )
889 {
890 char name[512];
891 struct stat astat;
892
893 name[0] = 'a'; name[1] = '\0';
894 if (! stat(name, &astat))
895 *nbyte = (int)(astat.st_size);
896 else
897 *nbyte = -1;
898 }
899 EOF
900 make genmake_tc_1.o >> genmake_tc.log 2>&1
901 RET_C=$?
902 cat <<EOF > genmake_tc_2.$FS
903 program hello
904 integer nbyte
905 call tfsize(nbyte)
906 print *," HELLO WORLD", nbyte
907 end
908 EOF
909 echo >> genmake_warnings
910 echo "running: check_HAVE_STAT()" >> genmake_warnings
911 cat genmake_tc_2.$FS >> genmake_warnings
912 COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
913 echo $COMM >> genmake_warnings
914 $COMM >> genmake_tc.log 2>&1
915 RETVAL=$?
916 if test "x$RETVAL" = x0 ; then
917 HAVE_STAT=t
918 DEFINES="$DEFINES -DHAVE_STAT"
919 fi
920 rm -f genmake_tc*
921 }
922
923
924 check_netcdf_libs() {
925 if test ! "x$SKIP_NETCDF_CHECK" = x ; then
926 return
927 fi
928 echo >> genmake_warnings
929 echo "running: check_netcdf_libs()" >> genmake_warnings
930 cat <<EOF > genmake_tnc.F
931 program fgennc
932 #include "netcdf.inc"
933 EOF
934 if test ! "x$MPI" = x ; then
935 echo '#include "mpif.h"' >> genmake_tnc.F
936 fi
937 cat <<EOF >> genmake_tnc.F
938 integer iret, ncid, xid
939 iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)
940 IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
941 iret = nf_def_dim(ncid, 'X', 11, xid)
942 IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
943 iret = nf_close(ncid)
944 IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
945 end
946 EOF
947 echo "=== genmake_tnc.F ===" > genmake_tnc.log
948 cat genmake_tnc.F >> genmake_tnc.log
949 echo "=== genmake_tnc.F ===" >> genmake_tnc.log
950 RET_CPP=f
951 COMM="cat genmake_tnc.F | $CPP $DEFINES $INCLUDES"
952 echo "$COMM" >> genmake_tnc.log
953 eval $COMM > genmake_tnc.$FS 2>/dev/null && RET_CPP=t
954 if test "x$RET_CPP" = xf ; then
955 echo " WARNING: CPP failed to pre-process the netcdf test." \
956 >> genmake_tnc.log
957 echo " Please check that \$INCLUDES is properly set." \
958 >> genmake_tnc.log
959 fi
960 echo "$FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
961 echo " && $LINK $FFLAGS $FOPTIM -o genmake_tnc.o $LIBS" >> genmake_tnc.log
962 $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1 \
963 && $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1
964 RET_COMPILE=$?
965 cat genmake_tnc.log >> genmake_warnings
966
967 #EH3 Remove test program execution for machines that either disallow
968 #EH3 execution or cannot support it (eg. cross-compilers)
969 #EH3
970 #EH3 test -x ./genmake_tnc && ./genmake_tnc >> genmake_tnc.log 2>&1
971 #EH3 RETVAL=$?
972 #EH3 if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
973
974 if test "x$RET_COMPILE" = x0 ; then
975 HAVE_NETCDF=t
976 else
977 # try again with "-lnetcdf" added to the libs
978 echo "try again with added '-lnetcdf'" > genmake_tnc.log
979 echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log
980 echo " && $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
981 echo " && $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
982 cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS 2>/dev/null \
983 && $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1 \
984 && $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1
985 RET_COMPILE=$?
986 cat genmake_tnc.log >> genmake_warnings
987 if test "x$RET_COMPILE" = x0 ; then
988 LIBS="$LIBS -lnetcdf"
989 HAVE_NETCDF=t
990 else
991 # try again with "-lnetcdff" added to the libs
992 echo "try again with added '-lnetcdff -lnetcdf'" > genmake_tnc.log
993 echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log
994 echo " && $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
995 echo " && $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
996 cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS 2>/dev/null \
997 && $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1 \
998 && $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdff -lnetcdf >> genmake_tnc.log 2>&1
999 RET_COMPILE=$?
1000 cat genmake_tnc.log >> genmake_warnings
1001 if test "x$RET_COMPILE" = x0 ; then
1002 LIBS="$LIBS -lnetcdff -lnetcdf"
1003 HAVE_NETCDF=t
1004 fi
1005 fi
1006 fi
1007 rm -f genmake_tnc*
1008 }
1009
1010
1011
1012 ###############################################################################
1013 # Sequential part of script starts here
1014 ###############################################################################
1015
1016 # Set defaults here
1017 COMMANDL="$0 $@"
1018
1019 PLATFORM=
1020 LN=
1021 S64=
1022 KPP=
1023 #FC=
1024 #CC=gcc
1025 #CPP=
1026 LINK=
1027 DEFINES=
1028 PACKAGES=
1029 ENABLE=
1030 DISABLE=
1031 # MAKEFILE=
1032 # MAKEDEPEND=
1033 PDEPEND=
1034 DUMPSTATE=t
1035 PDEFAULT=
1036 OPTFILE=
1037 INCLUDES="-I. $INCLUDES"
1038 FFLAGS=
1039 FOPTIM=
1040 CFLAGS=
1041 KFLAGS1=
1042 KFLAGS2=
1043 #LDADD=
1044 LIBS=
1045 KPPFILES=
1046 NOOPTFILES=
1047 NOOPTFLAGS=
1048 MPI=
1049 MPIPATH=
1050 TS=
1051 PAPIS=
1052 PCLS=
1053 FOOLAD=
1054 PAPI=
1055 PCL=
1056 HPMT=
1057 GSL=
1058 DEVEL=
1059 HAVE_TEST_L=
1060
1061 # DEFINES checked by test compilation or command-line
1062 HAVE_SYSTEM=
1063 HAVE_FDATE=
1064 FC_NAMEMANGLE=
1065 HAVE_CLOC=
1066 # HAVE_SETRLSTK=
1067 HAVE_STAT=
1068 HAVE_NETCDF=
1069 HAVE_ETIME=
1070 IGNORE_TIME=
1071
1072 MODS=
1073 TOOLSDIR=
1074 SOURCEDIRS=
1075 INCLUDEDIRS=
1076 STANDARDDIRS="USE_THE_DEFAULT"
1077
1078 G2ARGS=
1079 BASH=
1080 PWD=`pwd`
1081 test "x$MAKE" = x && MAKE=make
1082 test "x$AWK" = x && AWK=awk
1083 EMBED_SRC=
1084 THISHOST=`hostname`
1085 THISCWD=`pwd`
1086 THISDATE=`date`
1087 THISUSER=`echo $USER`
1088 THISVER=
1089 MACHINE=`uname -a`
1090 EXECUTABLE=
1091 EXEHOOK=
1092 EXEDIR=
1093 PACKAGES_CONF=
1094 IEEE=
1095 if test "x$MITGCM_IEEE" != x ; then
1096 IEEE=$MITGCM_IEEE
1097 fi
1098 FS=
1099 FS90=
1100
1101 AUTODIFF_PKG_USED=f
1102 AD_OPTFILE=
1103 TAF=
1104 AD_TAF_FLAGS=
1105 FTL_TAF_FLAGS=
1106 SVD_TAF_FLAGS=
1107 TAF_EXTRA=
1108 TAMC=
1109 AD_TAMC_FLAGS=
1110 FTL_TAF_FLAGS=
1111 SVD_TAMC_FLAGS=
1112 TAMC_EXTRA=
1113
1114
1115 # The following state can be set directly by command-line switches
1116 gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
1117 gm_s2="FC CPP IEEE TS PAPIS PCLS PAPI PCL HPMT GSL DEVEL MPI JAM DUMPSTATE STANDARDDIRS"
1118
1119 # The following state is not directly set by command-line switches
1120 gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
1121 gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
1122 gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOST THISUSER THISDATE THISVER MACHINE"
1123 gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
1124 gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE HAVE_ETIME"
1125
1126 # The following are all related to adjoint/tangent-linear stuff
1127 gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"
1128 gm_s11="FTL_TAMC_FLAGS FTL_TAF_FLAGS SVD_TAMC_FLAGS SVD_TAF_FLAGS"
1129 gm_s12="TAF_EXTRA TAMC_EXTRA"
1130
1131 gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6 $gm_s7"
1132 gm_state="$gm_state $gm_s10 $gm_s11 $gm_s12"
1133
1134 cat <<EOF
1135
1136 GENMAKE :
1137
1138 A program for GENerating MAKEfiles for the MITgcm project. For a
1139 quick list of options, use "genmake -h" or for more detail see:
1140
1141 http://mitgcm.org/devel_HOWTO/
1142
1143 EOF
1144
1145 echo "=== Processing options files and arguments ==="
1146 gm_local="genmake_local"
1147 for i in . $MODS ; do
1148 if test -r $i/$gm_local ; then
1149 . $i/$gm_local
1150 break
1151 fi
1152 done
1153 printf " getting local config information: "
1154 if test -f $gm_local ; then
1155 echo "using $gm_local"
1156 . $gm_local
1157 # echo "DISABLE=$DISABLE"
1158 # echo "ENABLE=$ENABLE"
1159 else
1160 echo "none found"
1161 fi
1162
1163 #echo "$0::$1:$2:$3:$4:$5:$6:$7:"
1164 #OPTIONS=
1165 #n=0
1166 #for i ; do
1167 # echo "$i $n"
1168 # setvar="OPTIONS[$n]='$i'"
1169 # # echo " $setvar"
1170 # eval "$setvar"
1171 # n=$(( $n + 1 ))
1172 #done
1173 #parse_options
1174 ac_prev=
1175 for ac_option in "$@" ; do
1176
1177 G2ARGS="$G2ARGS \"$ac_option\""
1178
1179 # If the previous option needs an argument, assign it.
1180 if test -n "$ac_prev"; then
1181 eval "$ac_prev=\$ac_option"
1182 ac_prev=
1183 continue
1184 fi
1185
1186 ac_optarg=`expr "x$ac_option" : 'x[^=]*=\(.*\)'`
1187
1188 case $ac_option in
1189
1190 -help | --help | -h | --h)
1191 usage ;;
1192
1193 -nooptfile | --nooptfile)
1194 OPTFILE="NONE" ;;
1195 -optfile | --optfile | -of | --of)
1196 ac_prev=OPTFILE ;;
1197 -optfile=* | --optfile=* | -of=* | --of=*)
1198 OPTFILE=$ac_optarg ;;
1199
1200 -adoptfile | --adoptfile | -adof | --adof)
1201 ac_prev=AD_OPTFILE ;;
1202 -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)
1203 AD_OPTFILE=$ac_optarg ;;
1204
1205 -pdepend | --pdepend)
1206 ac_prev=PDEPEND ;;
1207 -pdepend=* | --pdepend=*)
1208 PDEPEND=$ac_optarg ;;
1209
1210 -pdefault | --pdefault)
1211 ac_prev=PDEFAULT ;;
1212 -pdefault=* | --pdefault=*)
1213 PDEFAULT=$ac_optarg ;;
1214
1215 -make | --make | -m | --m)
1216 ac_prev=MAKE ;;
1217 -make=* | --make=* | -m=* | --m=*)
1218 MAKE=$ac_optarg ;;
1219
1220 -bash | --bash)
1221 ac_prev=BASH ;;
1222 -bash=* | --bash=*)
1223 BASH=$ac_optarg ;;
1224
1225 -makedepend | --makedepend | -md | --md)
1226 ac_prev=MAKEDEPEND ;;
1227 -makedepend=* | --makedepend=* | -md=* | --md=*)
1228 MAKEDEPEND=$ac_optarg ;;
1229
1230 -makefile | --makefile | -ma | --ma)
1231 ac_prev=MAKEFILE ;;
1232 -makefile=* | --makefile=* | -ma=* | --ma=*)
1233 MAKEFILE=$ac_optarg ;;
1234
1235 -platform | --platform | -pl | --pl | -platform=* | --platform=* | -pl=* | --pl=*)
1236 echo "ERROR: The platform option has been removed. Please specify"
1237 echo " the build options using the \"optfile\" mechanism."
1238 echo
1239 usage
1240 ;;
1241
1242 -rootdir | --rootdir | -rd | --rd)
1243 ac_prev=ROOTDIR ;;
1244 -rootdir=* | --rootdir=* | -rd=* | --rd=*)
1245 ROOTDIR=$ac_optarg ;;
1246
1247 -mods | --mods | -mo | --mo)
1248 ac_prev=MODS ;;
1249 -mods=* | --mods=* | -mo=* | --mo=*)
1250 MODS=$ac_optarg ;;
1251
1252 -disable | --disable)
1253 ac_prev=DISABLE ;;
1254 -disable=* | --disable=*)
1255 DISABLE=$ac_optarg ;;
1256
1257 -enable | --enable)
1258 ac_prev=ENABLE ;;
1259 -enable=* | --enable=*)
1260 ENABLE=$ac_optarg ;;
1261
1262 -standarddirs | --standarddirs)
1263 ac_prev=STANDARDDIRS ;;
1264 -standarddirs=* | --standarddirs=*)
1265 STANDARDDIRS=$ac_optarg ;;
1266
1267 # -cpp | --cpp)
1268 # ac_prev=cpp ;;
1269 # -cpp=* | --cpp=*)
1270 # CPP=$ac_optarg ;;
1271
1272 -cc | --cc)
1273 ac_prev=CC ;;
1274 -cc=* | --cc=*)
1275 CC=$ac_optarg ;;
1276
1277 -fortran | --fortran | -fc | --fc)
1278 ac_prev=FC ;;
1279 -fc=* | --fc=*)
1280 FC=$ac_optarg ;;
1281
1282 -fs | --fs)
1283 ac_prev=FS ;;
1284 -fs=* | --fs=*)
1285 FS=$ac_optarg ;;
1286
1287 -fs90 | --fs90)
1288 ac_prev=FS90 ;;
1289 -fs90=* | --fs90=*)
1290 FS90=$ac_optarg ;;
1291
1292 -ieee | --ieee)
1293 IEEE=true ;;
1294 -noieee | --noieee)
1295 IEEE= ;;
1296
1297 -ts | --ts)
1298 TS=true ;;
1299 -papis | --papis)
1300 PAPIS=true ;;
1301 -pcls | --pcls)
1302 PCLS=true ;;
1303 -foolad | --foolad)
1304 FOOLAD=true ;;
1305 -papi | --papi)
1306 PAPI=true ;;
1307 -pcl | --pcl)
1308 PCL=true ;;
1309 -hpmt | --hpmt)
1310 HPMT=true ;;
1311
1312 -gsl | --gsl)
1313 GSL=true ;;
1314
1315 -devel | --devel)
1316 DEVEL=true ;;
1317
1318 -mpi | --mpi)
1319 MPI=true ;;
1320 -mpi=* | --mpi=*)
1321 MPIPATH=$ac_optarg
1322 MPI=true ;;
1323
1324 # -jam | --jam)
1325 # JAM=1 ;;
1326 # -nojam | --nojam)
1327 # JAM=0 ;;
1328
1329 -ds | --ds)
1330 DUMPSTATE=t ;;
1331
1332 -taf_extra | --taf_extra)
1333 ac_prev=TAF_EXTRA ;;
1334 -taf_extra=* | --taf_extra=*)
1335 TAF_EXTRA=$ac_optarg ;;
1336
1337 -tamc_extra | --tamc_extra)
1338 ac_prev=TAMC_EXTRA ;;
1339 -tamc_extra=* | --tamc_extra=*)
1340 TAMC_EXTRA=$ac_optarg ;;
1341
1342 -ignoretime | -ignore_time | --ignoretime | --ignore_time)
1343 IGNORE_TIME="-DIGNORE_TIME" ;;
1344
1345 -es | --es | -embed-source | --embed-source)
1346 EMBED_SRC=t ;;
1347
1348 -*)
1349 echo "Error: unrecognized option: "$ac_option
1350 usage
1351 ;;
1352
1353 *)
1354 echo "Error: unrecognized argument: "$ac_option
1355 usage
1356 ;;
1357
1358 esac
1359
1360 done
1361
1362
1363 if test -f ./.genmakerc ; then
1364 echo
1365 echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""
1366 echo " file. This file format is no longer supported. For directions on"
1367 echo " how to setup and use the new \"genmake2\" script, please see:"
1368 echo " http://mitgcm.org/devel_HOWTO/"
1369 echo " and send an email to MITgcm-support@mitgcm.org if you need help."
1370 echo "WARNING: ignore \"./.genmakerc\" and continue."
1371 echo
1372 fi
1373
1374 # Find the MITgcm ${ROOTDIR}
1375 if test "x${ROOTDIR}" = x ; then
1376 tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`
1377 if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesupp -a -d ../pkg ; then
1378 ROOTDIR=".."
1379 else
1380 for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
1381 if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then
1382 ROOTDIR=$d
1383 printf "Warning: ROOTDIR was not specified but there appears to be"
1384 echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."
1385 break
1386 fi
1387 done
1388 fi
1389 fi
1390 if test "x${ROOTDIR}" = x ; then
1391 echo "Error: Cannot determine ROOTDIR for MITgcm code."
1392 echo " Please specify a ROOTDIR using either an options "
1393 echo " file or a command-line option."
1394 exit 1
1395 fi
1396 if test ! -d ${ROOTDIR} ; then
1397 echo "Error: the specified ROOTDIR (\"$ROOTDIR\") does not exist!"
1398 exit 1
1399 fi
1400
1401 # Find the MITgcm ${THISVER}
1402 if test -f "${ROOTDIR}/doc/tag-index" ; then
1403 THISVER=`grep '^checkpoint' ${ROOTDIR}/doc/tag-index | head -1`
1404 fi
1405
1406 if test "x$MAKEFILE" = x ; then
1407 MAKEFILE="Makefile"
1408 fi
1409
1410 echo " getting OPTFILE information: "
1411 if test "x${OPTFILE}" = x ; then
1412 if test "x$MITGCM_OF" = x ; then
1413 echo "Warning: no OPTFILE specified so we'll look for possible settings"
1414 printf "\n=== Searching for possible settings for OPTFILE ===\n"
1415 find_possible_configs
1416 else
1417 OPTFILE=$MITGCM_OF
1418 fi
1419 fi
1420 if test "x$OPTFILE" != xNONE ; then
1421 if test -f "$OPTFILE" -a -r "$OPTFILE" ; then
1422 echo " using OPTFILE=\"$OPTFILE\""
1423 . "$OPTFILE"
1424 RETVAL=$?
1425 if test "x$RETVAL" != x0 ; then
1426 printf "Error: failed to source OPTFILE \"$OPTFILE\""
1427 echo "--please check that variable syntax is bash-compatible"
1428 exit 1
1429 fi
1430 if test "x$DUMPSTATE" != xf ; then
1431 cp -f $OPTFILE "genmake_optfile"
1432 fi
1433 else
1434 echo "Error: can't read OPTFILE=\"$OPTFILE\""
1435 exit 1
1436 fi
1437 fi
1438
1439 echo " getting AD_OPTFILE information: "
1440 if test "x${AD_OPTFILE}" = x ; then
1441 if test "x$MITGCM_AD_OF" = x ; then
1442 AD_OPTFILE=$ROOTDIR/tools/adjoint_options/adjoint_default
1443 else
1444 AD_OPTFILE=$MITGCM_AD_OF
1445 fi
1446 fi
1447 if test "x${AD_OPTFILE}" != xNONE ; then
1448 if test -f "$AD_OPTFILE" -a -r "$AD_OPTFILE" ; then
1449 echo " using AD_OPTFILE=\"$AD_OPTFILE\""
1450 . "$AD_OPTFILE"
1451 RETVAL=$?
1452 if test "x$RETVAL" != x0 ; then
1453 printf "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""
1454 echo "--please check that variable syntax is bash-compatible"
1455 exit 1
1456 fi
1457 if test "x$DUMPSTATE" != xf ; then
1458 cp -f $AD_OPTFILE "genmake_ad_optfile"
1459 fi
1460 else
1461 echo "Error: can't read AD_OPTFILE=\"$AD_OPTFILE\""
1462 exit 1
1463 fi
1464 fi
1465
1466 #====================================================================
1467 # Set default values if not set by the optfile
1468 #
1469 # Check that FC, CC, LINK, CPP, S64, LN, and MAKE are defined. If not,
1470 # either set defaults or complain and abort!
1471 if test ! "x$BASH" = x ; then
1472 # add a trailing space so that it works within the Makefile syntax (see below)
1473 BASH="$BASH "
1474 fi
1475 if test "x$FC" = x ; then
1476 cat <<EOF 1>&2
1477
1478 Error: no Fortran compiler: please specify using one of the following:
1479 1) within the options file ("FC=...") as specified by "-of=OPTFILE"
1480 2) the "-fc=XXX" command-line option
1481 3) the "./genmake_local" file
1482 EOF
1483 exit 1
1484 fi
1485 if test "x$CC" = x ; then
1486 CC=cc
1487 # cat <<EOF 1>&2
1488 # Error: no C compiler: please specify using one of the following:
1489 # 1) within the options file ("CC=...") as specified by "-of=OPTFILE"
1490 # 2) the "-cc=XXX" command-line option
1491 # 3) the "./genmake_local" file
1492 # EOF
1493 # exit 1
1494 fi
1495 if test "x$LINK" = x ; then
1496 LINK=$FC
1497 fi
1498 if test "x$MAKE" = x ; then
1499 MAKE="make"
1500 fi
1501 if test "x$CPP" = x ; then
1502 CPP=cpp
1503 fi
1504 #EH3 === UGLY ===
1505 # The following is an ugly little hack to check for $CPP in /lib/ and
1506 # it should eventually be replaced with a more general function that
1507 # searches a combo of the user's path and a list of "usual suspects"
1508 # to find the correct location for binaries such as $CPP.
1509 for i in " " "/lib/" ; do
1510 echo "#define A a" | $i$CPP > test_cpp 2>&1 && CPP=$i$CPP
1511 done
1512 #EH3 === UGLY ===
1513 echo "#define A a" | $CPP > test_cpp 2>&1
1514 RETVAL=$?
1515 if test "x$RETVAL" != x0 ; then
1516 cat <<EOF 1>&2
1517
1518 Error: C pre-processor "$CPP" failed the test case: please specify using:
1519
1520 1) within the options file ("CPP=...") as specified by "-of=OPTFILE"
1521 2) the "./genmake_local" file
1522 3) with the CPP environment variable
1523
1524 EOF
1525 exit 1
1526 else
1527 rm -f test_cpp
1528 fi
1529 look_for_makedepend
1530 if test "x$LN" = x ; then
1531 LN="ln -s"
1532 fi
1533 echo "test" > genmake_test_ln
1534 $LN genmake_test_ln genmake_tlink
1535 RETVAL=$?
1536 if test "x$RETVAL" != x0 ; then
1537 cat <<EOF 1>&2
1538
1539 Error: The command "ln -s" failed -- please specify a working soft-link
1540 command in the optfile.
1541
1542 EOF
1543 exit 1
1544 fi
1545 test -L genmake_tlink > /dev/null 2>&1
1546 RETVAL=$?
1547 if test "x$RETVAL" = x0 ; then
1548 HAVE_TEST_L=t
1549 fi
1550 rm -f genmake_test_ln genmake_tlink
1551
1552 # Check for broken *.F/*.f handling and fix if possible
1553 check_for_broken_Ff
1554
1555 if test ! "x$MPI" = x ; then
1556 echo " Turning on MPI cpp macros"
1557 DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"
1558 fi
1559
1560 if test ! "x$TS" = x ; then
1561 echo " Turning on timing per timestep"
1562 if test ! "x$FOOLAD" = x ; then
1563 DEFINES="$DEFINES -DTIME_PER_TIMESTEP_SFP"
1564 else
1565 DEFINES="$DEFINES -DTIME_PER_TIMESTEP"
1566 fi
1567 fi
1568 if test ! "x$PAPIS" = x ; then
1569 echo " Turning on PAPI flop summary per timestep"
1570 echo " Please make sure PAPIINC, PAPILIB are defined"
1571 if test ! "x$FOOLAD" = x ; then
1572 DEFINES="$DEFINES -DUSE_PAPI_FLOPS_SFP"
1573 else
1574 DEFINES="$DEFINES -DUSE_PAPI_FLOPS"
1575 fi
1576 INCLUDES="$INCLUDES $PAPIINC"
1577 LIBS="$LIBS $PAPILIB"
1578 fi
1579 if test ! "x$PCLS" = x ; then
1580 echo " Turning on PCL counter summary per timestep"
1581 echo " Please make sure PCLINC, PCLLIB are defined"
1582 if test ! "x$FOOLAD" = x ; then
1583 DEFINES="$DEFINES -DUSE_PCL_FLOPS_SFP"
1584 else
1585 DEFINES="$DEFINES -DUSE_PCL_FLOPS"
1586 fi
1587 INCLUDES="$INCLUDES $PCLINC"
1588 LIBS="$LIBS $PCLLIB"
1589 fi
1590 if test ! "x$PAPI" = x ; then
1591 if test ! "x$PAPIS" = x ; then
1592 echo " PAPI performance analysis and flop summary per timestep cannot co-exist!"
1593 echo " Sticking with PAPI flop summary per timestep!"
1594 else
1595 echo " Turning on performance analysis with PAPI"
1596 echo " Please make sure PAPIINC, PAPILIB are defined"
1597 DEFINES="$DEFINES -DUSE_PAPI"
1598 INCLUDES="$INCLUDES $PAPIINC"
1599 LIBS="$LIBS $PAPILIB"
1600 fi
1601 fi
1602 if test ! "x$PCL" = x ; then
1603 if test ! "x$PCLS" = x ; then
1604 echo " PCL performance analysis and flop summary per timestep cannot co-exist!"
1605 echo " Sticking with PCL flop summary per timestep!"
1606 else
1607 echo " Turning on performance analysis with PCL"
1608 echo " Please make sure PCLINC, PCLLIB are defined"
1609 DEFINES="$DEFINES -DUSE_PCL"
1610 INCLUDES="$INCLUDES $PCLINC"
1611 LIBS="$LIBS $PCLLIB"
1612 fi
1613 fi
1614 if test ! "x$HPMT" = x ; then
1615 if test ! "x$PAPI" = x ; then
1616 echo " PAPI and the HPM Toolkit cannot co-exist!"
1617 echo " Sticking with PAPI!"
1618 else if test ! "x$PCL" = x ; then
1619 echo " PCL and the HPM Toolkit cannot co-exist!"
1620 echo " Sticking with PCL!"
1621 else
1622 echo " Turning on performance analysis with the HPM Toolkit"
1623 echo " Please make sure HPMTINC, HPMTLIB are defined"
1624 DEFINES="$DEFINES -DUSE_LIBHPM"
1625 INCLUDES="$INCLUDES $HPMTINC"
1626 LIBS="$LIBS $HPMTLIB"
1627 fi
1628 fi
1629 fi
1630 if test ! "x$GSL" = x ; then
1631 echo " Turning on use of GSL to control floating point calculations"
1632 echo " Please make sure GSLINC, GSLLIB are defined"
1633 DEFINES="$DEFINES -DUSE_GSL_IEEE"
1634 INCLUDES="$INCLUDES $GSLINC"
1635 LIBS="$LIBS $GSLLIB"
1636 fi
1637
1638 printf "\n=== Checking system libraries ===\n"
1639 printf " Do we have the system() command using $FC... "
1640 cat > genmake_tcomp.$FS <<EOF
1641 program hello
1642 call system('echo hi')
1643 end
1644 EOF
1645 $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1646 RETVAL=$?
1647 if test "x$RETVAL" = x0 ; then
1648 HAVE_SYSTEM=t
1649 DEFINES="$DEFINES -DHAVE_SYSTEM"
1650 echo "yes"
1651 else
1652 HAVE_SYSTEM=
1653 echo "no"
1654 fi
1655 rm -f genmake_tcomp*
1656
1657 printf " Do we have the fdate() command using $FC... "
1658 cat > genmake_tcomp.$FS <<EOF
1659 program hello
1660 CHARACTER*(128) string
1661 string = ' '
1662 call fdate( string )
1663 print *, string
1664 end
1665 EOF
1666 $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1667 RETVAL=$?
1668 if test "x$RETVAL" = x0 ; then
1669 HAVE_FDATE=t
1670 DEFINES="$DEFINES -DHAVE_FDATE"
1671 echo "yes"
1672 else
1673 HAVE_FDATE=
1674 echo "no"
1675 fi
1676 rm -f genmake_tcomp*
1677
1678 printf " Do we have the etime() command using $FC... "
1679 cat > genmake_tcomp.$FS <<EOF
1680 program hello
1681 REAL*4 ACTUAL, TARRAY(2)
1682 EXTERNAL ETIME
1683 REAL*4 ETIME
1684 actual = etime( tarray )
1685 print *, tarray
1686 end
1687 EOF
1688 $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1689 RETVAL=$?
1690 if test "x$RETVAL" = x0 ; then
1691 HAVE_ETIME=t
1692 DEFINES="$DEFINES -DHAVE_ETIME"
1693 echo "yes"
1694 else
1695 HAVE_ETIME=
1696 echo "no"
1697 fi
1698 rm -f genmake_tcomp*
1699
1700 printf " Can we call simple C routines (here, \"cloc()\") using $FC... "
1701 check_HAVE_CLOC
1702 if test "x$HAVE_CLOC" != x ; then
1703 echo "yes"
1704 else
1705 echo "no"
1706 if test "x$EMBED_SRC" = xt ; then
1707 echo " WARNING: you requested file embedding but it has"
1708 echo " been disabled since C code cannot be called"
1709 EMBED_SRC=
1710 fi
1711 fi
1712 rm -f genmake_t*
1713
1714 printf " Can we unlimit the stack size using $FC... "
1715 check_HAVE_SETRLSTK
1716 if test "x$HAVE_SETRLSTK" = xt ; then
1717 echo "yes"
1718 else
1719 echo "no"
1720 fi
1721 rm -f genmake_t*
1722
1723 printf " Can we register a signal handler using $FC... "
1724 check_HAVE_SIGREG
1725 if test "x$HAVE_SIGREG" = xt ; then
1726 echo "yes"
1727 else
1728 echo "no"
1729 fi
1730 rm -f genmake_t*
1731
1732 printf " Can we use stat() through C calls... "
1733 check_HAVE_STAT
1734 if test "x$HAVE_STAT" != x ; then
1735 echo "yes"
1736 else
1737 echo "no"
1738 fi
1739 rm -f genmake_t*
1740
1741 printf " Can we create NetCDF-enabled binaries... "
1742 check_netcdf_libs
1743 if test "x$HAVE_NETCDF" != x ; then
1744 echo "yes"
1745 else
1746 echo "no"
1747 fi
1748 DEFINES="$DEFINES $IGNORE_TIME"
1749
1750 if test "x$EMBED_SRC" = xt ; then
1751 build_embed_encode
1752 fi
1753 if test "x$EMBED_SRC" = xt ; then
1754 ENABLE="$ENABLE embed_files"
1755 fi
1756
1757
1758 printf "\n=== Setting defaults ===\n"
1759 printf " Adding MODS directories: "
1760 for d in $MODS ; do
1761 if test ! -d $d ; then
1762 echo
1763 echo "Error: MODS directory \"$d\" not found!"
1764 exit 1
1765 else
1766 printf " $d"
1767 SOURCEDIRS="$SOURCEDIRS $d"
1768 INCLUDEDIRS="$INCLUDEDIRS $d"
1769 fi
1770 done
1771 echo
1772
1773 if test "x${PLATFORM}" = x ; then
1774 PLATFORM=$p_PLATFORM
1775 fi
1776
1777 if test "x${EXEDIR}" = x ; then
1778 tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`
1779 if test "x$tmp" = "xbin" -a -d ../exe -a $ROOTDIR = .. ; then
1780 EXEDIR=../exe
1781 else
1782 EXEDIR=.
1783 fi
1784 fi
1785 if test ! -d ${EXEDIR} ; then
1786 echo "Error: the specified EXEDIR (\"$EXEDIR\") does not exist!"
1787 exit 1
1788 fi
1789
1790 if test "x${TOOLSDIR}" = x ; then
1791 TOOLSDIR="$ROOTDIR/tools"
1792 fi
1793 if test ! -d ${TOOLSDIR} ; then
1794 echo "Error: the specified TOOLSDIR (\"$TOOLSDIR\") does not exist!"
1795 exit 1
1796 fi
1797 if test "x$S64" = x ; then
1798 echo "3.0 _d 3" | ${TOOLSDIR}/set64bitConst.sh > /dev/null 2>&1
1799 RETVAL=$?
1800 if test "x${RETVAL}" = x0 ; then
1801 S64='$(TOOLSDIR)/set64bitConst.sh'
1802 else
1803 echo "3.0 _d 3" | ${TOOLSDIR}/set64bitConst.csh > /dev/null 2>&1
1804 RETVAL=$?
1805 if test "x${RETVAL}" = x0 ; then
1806 S64='$(TOOLSDIR)/set64bitConst.csh'
1807 else
1808 cat <<EOF
1809
1810 ERROR: neither of the two default scripts:
1811
1812 ${TOOLSDIR}/set64bitConst.sh
1813 ${TOOLSDIR}/set64bitConst.csh
1814
1815 are working so please check paths or specify (with \$S64) a
1816 working version of this script.
1817
1818 EOF
1819 exit 1
1820 fi
1821 fi
1822 fi
1823 THIS_SCRIPT=`echo ${0} | sed 's:'$TOOLSDIR':\$(TOOLSDIR):'`
1824
1825 EXECUTABLE=${EXECUTABLE:-mitgcmuv}
1826
1827 # We have a special set of source files in eesupp/src which are
1828 # generated from some template source files. We'll make them first so
1829 # they appear as regular source code
1830 if test -r $ROOTDIR"/eesupp/src/Makefile" ; then
1831 echo " Making source files in eesupp from templates"
1832 ( cd $ROOTDIR"/eesupp/src/" && $MAKE ) > make_eesupp.errors 2>&1
1833 RETVAL=$?
1834 if test "x${RETVAL}" = x0 ; then
1835 rm -f make_eesupp.errors
1836 else
1837 echo "Error: problem encountered while building source files in eesupp:"
1838 cat make_eesupp.errors 1>&2
1839 exit 1
1840 fi
1841 fi
1842
1843 #same for pkg/exch2 and pkg/regrid
1844 for pdir in exch2 regrid ; do
1845 if test -r $ROOTDIR"/pkg/${pdir}/Makefile" ; then
1846 echo " Making source files in pkg/${pdir} from templates"
1847 ( cd $ROOTDIR"/pkg/"${pdir} && $MAKE ) > make_${pdir}.errors 2>&1
1848 RETVAL=$?
1849 if test "x${RETVAL}" = x0 ; then
1850 rm -f make_${pdir}.errors
1851 else
1852 echo "Error: problem encountered while building source files in pkg/${pdir}:"
1853 cat make_${pdir}.errors 1>&2
1854 exit 1
1855 fi
1856 fi
1857 done
1858
1859 printf "\n=== Determining package settings ===\n"
1860 if test "x${PDEPEND}" = x ; then
1861 tmp=$ROOTDIR"/pkg/pkg_depend"
1862 if test -r $tmp ; then
1863 PDEPEND=$tmp
1864 else
1865 echo "Warning: No package dependency information was specified."
1866 echo " Please check that ROOTDIR/pkg/pkg_depend exists."
1867 fi
1868 else
1869 if test ! -r ${PDEPEND} ; then
1870 echo "Error: can't read package dependency info from PDEPEND=\"$PDEPEND\""
1871 exit 1
1872 fi
1873 fi
1874 echo " getting package dependency info from $PDEPEND"
1875 # Strip the comments and then convert the dependency file into
1876 # two arrays: PNAME, DNAME
1877 cat $PDEPEND | sed -e 's/#.*$//g' \
1878 | $AWK 'BEGIN{nn=-1;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME_"nn"="$1"\nDNAME_"nn"="$i}} END{print "nname="nn}' \
1879 > ./.pd_tmp
1880 RETVAL=$?
1881 if test ! "x${RETVAL}" = x0 ; then
1882 echo "Error: unable to parse package dependencies -- please check PDEPEND=\"$PDEPEND\""
1883 exit 1
1884 fi
1885 . ./.pd_tmp
1886 rm -f ./.pd_tmp
1887
1888 # Search for default packages. Note that a "$ROOTDIR/pkg/pkg_groups"
1889 # file should eventually be added so that, for convenience, one can
1890 # specify groups of packages using names like "ocean" and "atmosphere".
1891 echo " checking default package list: "
1892 if test "x${PDEFAULT}" = x ; then
1893 for i in "." $MODS ; do
1894 if test -r $i"/packages.conf" ; then
1895 PDEFAULT=$i"/packages.conf"
1896 break
1897 fi
1898 done
1899 fi
1900 if test "x${PDEFAULT}" = x ; then
1901 PDEFAULT="$ROOTDIR/pkg/pkg_default"
1902 fi
1903 if test "x${PDEFAULT}" = xNONE ; then
1904 echo " default packages file disabled"
1905 else
1906 if test ! -r $PDEFAULT ; then
1907 echo "Warning: can't read default packages from PDEFAULT=\"$PDEFAULT\""
1908 else
1909 echo " using PDEFAULT=\"$PDEFAULT\""
1910 # Strip the comments and add all the names
1911 def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`
1912 RETVAL=$?
1913 if test "x${RETVAL}" != x0 ; then
1914 printf "Error: can't parse default package list "
1915 echo "-- please check PDEFAULT=\"$PDEFAULT\""
1916 exit 1
1917 fi
1918 for i in $def ; do
1919 PACKAGES="$PACKAGES $i"
1920 done
1921 echo " before group expansion packages are: $PACKAGES"
1922 RET=1
1923 while test $RET = 1 ; do expand_pkg_groups; RET=$?; done
1924 echo " after group expansion packages are: $PACKAGES"
1925 fi
1926 fi
1927
1928 echo " applying DISABLE settings"
1929 for i in $PACKAGES ; do
1930 echo $i >> ./.tmp_pack
1931 done
1932 for i in `grep "-" ./.tmp_pack` ; do
1933 j=`echo $i | sed 's/[-]//'`
1934 DISABLE="$DISABLE $j"
1935 done
1936 pack=
1937 for p in $PACKAGES ; do
1938 addit="t"
1939 for d in $DISABLE ; do
1940 if test "x$p" = "x$d" ; then
1941 addit="f"
1942 fi
1943 done
1944 if test "x$addit" = xt ; then
1945 pack="$pack $p"
1946 fi
1947 done
1948 PACKAGES="$pack"
1949 echo " applying ENABLE settings"
1950 echo "" > ./.tmp_pack
1951 PACKAGES="$PACKAGES $ENABLE"
1952 # Test if each explicitly referenced package exists
1953 for i in $PACKAGES ; do
1954 j=`echo $i | sed 's/[-+]//'`
1955 if test ! -d "$ROOTDIR/pkg/$j" ; then
1956 echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""
1957 exit 1
1958 fi
1959 echo $i >> ./.tmp_pack
1960 done
1961 PACKAGES=
1962 for i in `grep -v "-" ./.tmp_pack | sort | uniq` ; do
1963 PACKAGES="$PACKAGES $i"
1964 done
1965 rm -f ./.tmp_pack
1966 echo " packages are: $PACKAGES"
1967
1968 # Check for package MNC: if NetCDF is available, then build the MNC
1969 # template files ; otherwise, delete mnc from the list of packages.
1970 echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
1971 RETVAL=$?
1972 if test "x$RETVAL" = x0 ; then
1973 if test "x$HAVE_NETCDF" != xt ; then
1974 cat <<EOF
1975
1976 *********************************************************************
1977 WARNING: the "mnc" package was enabled but tests failed to compile
1978 NetCDF applications. Please check that:
1979
1980 1) NetCDF is correctly installed for this compiler and
1981 2) the LIBS variable (within the "optfile") specifies the correct
1982 NetCDF library to link against.
1983
1984 Due to this failure, the "mnc" package is now DISABLED.
1985 *********************************************************************
1986
1987 EOF
1988 PACKAGES=`echo $PACKAGES | sed -e 's/mnc//g'`
1989 DISABLE="$DISABLE mnc"
1990 else
1991 ( cd $ROOTDIR"/pkg/mnc" && $MAKE testclean && $MAKE templates ) > make_mnc.errors 2>&1
1992 RETVAL=$?
1993 if test "x${RETVAL}" = x0 ; then
1994 rm -f make_mnc.errors
1995 else
1996 echo "Error: problem encountered while building source files in pkg/mnc:"
1997 cat make_mnc.errors 1>&2
1998 exit 1
1999 fi
2000 fi
2001 fi
2002
2003 # Check for package PROFILES: if NetCDF is not available,
2004 # then delete profiles from the list of available packages.
2005 echo $PACKAGES | grep ' profiles ' > /dev/null 2>&1
2006 RETVAL=$?
2007 if test "x$RETVAL" = x0 ; then
2008 if test "x$HAVE_NETCDF" != xt ; then
2009 cat <<EOF
2010
2011 *********************************************************************
2012 WARNING: the "profiles" package was enabled but tests failed to
2013 compile NetCDF applications. Please check that:
2014
2015 1) NetCDF is correctly installed for this compiler and
2016 2) the LIBS variable (within the "optfile") specifies the correct
2017 NetCDF library to link against.
2018
2019 Due to this failure, the "profiles" package is now DISABLED.
2020 *********************************************************************
2021
2022 EOF
2023 PACKAGES=`echo $PACKAGES | sed -e 's/profiles//g'`
2024 DISABLE="$DISABLE profiles"
2025 fi
2026 fi
2027
2028 echo " applying package dependency rules"
2029 ck=
2030 while test "x$ck" != xtt ; do
2031 i=0
2032 # rtot=${#PNAME[@]}
2033 rtot=$nname
2034 while test $i -le $rtot ; do
2035
2036 # Is $pname in the current $PACKAGES list?
2037 # pname=${PNAME[$i]}
2038 tmp="pname=\"\$PNAME_$i\""
2039 eval $tmp
2040 pin="f"
2041 for p in $PACKAGES ; do
2042 if test "x$p" = "x$pname" ; then
2043 pin="t"
2044 fi
2045 done
2046
2047 # Is the DNAME entry a (+) or (-) rule ?
2048 tmp="dname=\"\$DNAME_$i\""
2049 eval $tmp
2050 plus="-"
2051 echo $dname | grep '^+' > /dev/null 2>&1
2052 RETVAL=$?
2053 if test "x$RETVAL" = x0 ; then
2054 plus="+"
2055 fi
2056
2057 # Is $dname in the current $PACKAGES list?
2058 dname=`echo $dname | sed -e 's/^[+-]//'`
2059 din="f"
2060 for p in $PACKAGES ; do
2061 if test "x$p" = "x$dname" ; then
2062 din="t"
2063 fi
2064 done
2065
2066 # Do we need to add $dname according to the dependency rules?
2067 if test "x$pin" = xt -a "x$plus" = "x+" -a "x$din" = xf ; then
2068 #echo " " $pname ": need to add :" $dname
2069 in_dis="f"
2070 for dis in $DISABLE ; do
2071 if test "x$dis" = "x$dname" ; then
2072 in_dis="t"
2073 fi
2074 done
2075 if test "x$in_dis" = xt ; then
2076 echo "Error: can't satisfy package dependencies:"
2077 echo " \"$dname\" is required by the dependency rules"
2078 echo " but is disallowed by the DISABLE settings"
2079 exit 1
2080 else
2081 PACKAGES="$PACKAGES $dname"
2082 ck=
2083 fi
2084 fi
2085
2086 # Do we need to get rid of $dname according to the dependency rules?
2087 if test "x$pin" = xt -a "x$plus" = "x-" -a "x$din" = xt; then
2088 echo "Error: can't satisfy package dependencies:"
2089 echo " \"$pname\" was requested but is disallowed by"
2090 echo " the dependency rules for \"$dname\""
2091 exit 1
2092 fi
2093 i=`echo "$i + 1" | bc -l`
2094 #i=$(( $i + 1 ))
2095 done
2096 ck=$ck"t"
2097 done
2098 echo " packages are: $PACKAGES"
2099 for i in $PACKAGES ; do
2100 adr="$ROOTDIR/pkg/$i"
2101 if test -d $adr ; then
2102 SOURCEDIRS="$SOURCEDIRS $adr"
2103 INCLUDEDIRS="$INCLUDEDIRS $adr"
2104 if test "x$i" = xautodiff ; then
2105 AUTODIFF_PKG_USED=t
2106 fi
2107 else
2108 echo "Error: the directory \"$adr\" for package $i doesn't exist"
2109 exit 1
2110 fi
2111 done
2112
2113 # Create a list of #define and #undef to enable/disable packages
2114 PACKAGES_DOT_H=PACKAGES_CONFIG.h
2115 # The following UGLY HACK sets multiple "#undef"s and it needs to go
2116 # away. On 2003-08-12, CNH, JMC, and EH3 agreed that the CPP_OPTIONS.h
2117 # file would eventually be split up so that all package-related #define
2118 # statements could be separated and handled only by genmake.
2119 names=`ls -1 "$ROOTDIR/pkg"`
2120 all_pack=
2121 DISABLED_PACKAGES=
2122 for n in $names ; do
2123 if test -d "$ROOTDIR/pkg/$n" -a "x$n" != xCVS ; then
2124 has_pack="f"
2125 for pack in $PACKAGES ; do
2126 if test "x$pack" = "x$n" ; then
2127 has_pack="t"
2128 break
2129 fi
2130 done
2131 if test "x$has_pack" = xf ; then
2132 undef=`echo "ALLOW_$n" | sed -e 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
2133 DISABLED_PACKAGES="$DISABLED_PACKAGES -U$undef"
2134 fi
2135 fi
2136 done
2137 ENABLED_PACKAGES=
2138 for i in $PACKAGES ; do
2139 def=`echo "ALLOW_$i" | sed -e 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
2140 ENABLED_PACKAGES="$ENABLED_PACKAGES -D$def"
2141 #eh3 DEFINES="$DEFINES -D$def"
2142
2143 #EH3 WARNING : This is an UGLY HACK that needs to be removed!!!
2144 case $i in
2145 aim_v23)
2146 ENABLED_PACKAGES="$ENABLED_PACKAGES -DALLOW_AIM"
2147 echo "Warning: ALLOW_AIM is set to enable aim_v23."
2148 ;;
2149 esac
2150 #EH3 WARNING : This is an UGLY HACK that needs to be removed!!!
2151
2152 done
2153
2154 echo " Adding STANDARDDIRS"
2155 BUILDDIR=${BUILDDIR:-.}
2156 if test "x$STANDARDDIRS" = xUSE_THE_DEFAULT ; then
2157 STANDARDDIRS="eesupp model"
2158 fi
2159 if test "x$STANDARDDIRS" != x ; then
2160 for d in $STANDARDDIRS ; do
2161 adr="$ROOTDIR/$d/src"
2162 if test ! -d $adr ; then
2163 echo "Error: directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
2164 echo " is correct and that you correctly specified the STANDARDDIRS option"
2165 exit 1
2166 else
2167 SOURCEDIRS="$SOURCEDIRS $adr"
2168 fi
2169 adr="$ROOTDIR/$d/inc"
2170 if test ! -d $adr ; then
2171 echo "Error: directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
2172 echo " is correct and that you correctly specified the STANDARDDIRS option"
2173 exit 1
2174 else
2175 INCLUDEDIRS="$INCLUDEDIRS $adr"
2176 fi
2177 done
2178 fi
2179
2180 echo " Searching for *OPTIONS.h files in order to warn about the presence"
2181 echo " of \"#define \"-type statements that are no longer allowed:"
2182 CPP_OPTIONS=
2183 CPP_EEOPTIONS=
2184 spaths=". $INCLUDEDIRS"
2185 names=`ls -1 "$ROOTDIR/pkg"`
2186 for i in $spaths ; do
2187 try="$i/CPP_OPTIONS.h"
2188 if test -f $try -a -r $try -a "x$CPP_OPTIONS" = x ; then
2189 echo " found CPP_OPTIONS=\"$try\""
2190 CPP_OPTIONS="$try"
2191 # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h
2192 for n in $names ; do
2193 test_for_package_in_cpp_options $CPP_OPTIONS $n
2194 done
2195 fi
2196 try="$i/CPP_EEOPTIONS.h"
2197 if test -f $try -a -r $try -a "x$CPP_EEOPTIONS" = x ; then
2198 echo " found CPP_EEOPTIONS=\"$try\""
2199 # New safety test: make sure MPI is not determined by CPP_EEOPTIONS.h
2200 #**** not yet enabled ****
2201 # test_for_mpi_in_cpp_eeoptions $try
2202 #**** not yet enabled ****
2203 CPP_EEOPTIONS="$try"
2204 fi
2205 done
2206 if test "x$CPP_OPTIONS" = x ; then
2207 echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"
2208 exit 1
2209 fi
2210
2211 # Here, we build the list of files to be "run through" the adjoint
2212 # compiler.
2213 if test -f ./ad_files ; then
2214 rm -f ./ad_files
2215 fi
2216 echo " Creating the list of files for the adjoint compiler."
2217 for i in $SOURCEDIRS ; do
2218 list_files=`( cd $i && ls -1 *.list 2>/dev/null )`
2219 for j in $list_files ; do
2220 cat $i/$j >> ad_files
2221 done
2222 done
2223 if test ! "x"$FS = "x.f" ; then
2224 cat ad_files | sed -e "s/\.f/.$FS/g" > ad_files_f
2225 mv -f ad_files_f ad_files
2226 fi
2227
2228 echo
2229 echo "=== Creating the Makefile ==="
2230 echo " setting INCLUDES"
2231 for i in $INCLUDEDIRS ; do
2232 if test ! -d $i ; then
2233 echo "Warning: can't find INCLUDEDIRS=\"$i\""
2234 fi
2235 done
2236
2237 if test ! "x$DIVA" = x ; then
2238 echo " Creating the pseudo-MPI include directory"
2239 INCLUDES="-I./mpi_headers $INCLUDES"
2240 rm -rf ./mpi_headers
2241 mkdir -p ./mpi_headers
2242
2243 if test "x$MPIINCLUDEDIR" = x ; then
2244 if test "x$MPIHOME" = x ; then
2245 MPIHOME='/usr'
2246 fi
2247 MPIINCLUDEDIR='$MPIHOME/include'
2248 fi
2249
2250 if test -r $MPIINCLUDEDIR/mpif.h ; then
2251 for i in $MPI_HEADER_FILES; do
2252 cp -p $MPIINCLUDEDIR/$i ./mpi_headers
2253 done
2254
2255 perl -i -pe 's/MPI_DISPLACEMENT_CURRENT=-1_8/MPI_DISPLACEMENT_CURRENT=-1/g' mpi_headers/mpif.h
2256 else
2257 echo " We cannot create a copy of mpif.h!"
2258 # exit -1
2259 fi
2260 fi
2261
2262 echo " Determining the list of source and include files"
2263 rm -rf .links.tmp
2264 mkdir .links.tmp
2265 touch .links.tmp/foo
2266 if test ! -r ".links.tmp/foo" ; then
2267 echo
2268 echo "ERROR : something is wrong with your directory permissions or"
2269 echo " your user file-creation mask (\"umask\") since creating a"
2270 echo " sub-dir, touch-ing a file within it, and then reading it is"
2271 echo " not working. Please try setting your umask to something"
2272 echo " sane such as:"
2273 echo
2274 echo " umask 0002"
2275 echo
2276 echo " and please verify that you have the proper permissions for"
2277 echo " creating sub-directories and then reading files created"
2278 echo " within them."
2279 echo
2280 exit 1
2281 fi
2282 rm -f .links.tmp/foo
2283 echo "# This section creates symbolic links" > srclinks.tmp
2284 echo "" >> srclinks.tmp
2285 printf 'SRCFILES = ' > srclist.inc
2286 printf 'CSRCFILES = ' > csrclist.inc
2287 printf 'F90SRCFILES = ' > f90srclist.inc
2288 printf 'HEADERFILES = ' > hlist.inc
2289 printf 'AD_FLOW_FILES = ' > ad_flow_files.inc
2290 alldirs="$SOURCEDIRS $INCLUDEDIRS ."
2291 for d in $alldirs ; do
2292 deplist=
2293 sfiles=`( cd $d; echo *.[h,c,F] *.flow )`
2294 sfiles=`( echo $sfiles; cd $d; echo *.F90 )`
2295 for sf in $sfiles ; do
2296 if test ! -r ".links.tmp/$sf" ; then
2297 if test -f "$d/$sf" ; then
2298 ignore_f=f
2299 case $d/$sf in
2300 ./$PACKAGES_DOT_H)
2301 ignore_f=t
2302 ;;
2303 ./AD_CONFIG.h)
2304 ignore_f=t
2305 ;;
2306 ./FC_NAMEMANGLE.h)
2307 ignore_f=t
2308 ;;
2309 ./BUILD_INFO.h)
2310 ignore_f=t
2311 ;;
2312 ./EMBEDDED_FILES.h)
2313 ignore_f=t
2314 ;;
2315 *)
2316 # For the local directory *ONLY*,
2317 # ignore all soft-links
2318 if test "x$HAVE_TEST_L" = xt -a "x$d" = x. -a -L $sf ; then
2319 ignore_f=t
2320 else
2321 touch .links.tmp/$sf
2322 deplist="$deplist $sf"
2323 fi
2324 ;;
2325 esac
2326 if test "x$ignore_f" = xf ; then
2327 extn=`echo $sf | $AWK -F. '{print $NF}'`
2328 case $extn in
2329 F)
2330 echo " \\" >> srclist.inc
2331 printf " $sf" >> srclist.inc
2332 ;;
2333 F90)
2334 echo " \\" >> f90srclist.inc
2335 printf " $sf" >> f90srclist.inc
2336 ;;
2337 c)
2338 echo " \\" >> csrclist.inc
2339 printf " $sf" >> csrclist.inc
2340 ;;
2341 h)
2342 echo " \\" >> hlist.inc
2343 printf " $sf" >> hlist.inc
2344 ;;
2345 flow)
2346 echo " \\" >> ad_flow_files.inc
2347 printf " $sf" >> ad_flow_files.inc
2348 ;;
2349 esac
2350 fi
2351 fi
2352 fi
2353 done
2354 if test "x$deplist" != x ; then
2355 echo "" >> srclinks.tmp
2356 echo "# These files are linked from $d" >> srclinks.tmp
2357 echo "$deplist :" >> srclinks.tmp
2358 printf "\t\$(LN) %s/\$@ \$@\n" $d >> srclinks.tmp
2359 fi
2360 done
2361 rm -rf .links.tmp
2362 echo "" >> srclist.inc
2363 echo "" >> csrclist.inc
2364 echo "" >> f90srclist.inc
2365 echo "" >> hlist.inc
2366 echo "" >> ad_flow_files.inc
2367
2368 if test -f $MAKEFILE ; then
2369 mv -f $MAKEFILE "$MAKEFILE.bak"
2370 fi
2371 echo " Writing makefile: $MAKEFILE"
2372 echo "# Multithreaded + multi-processing makefile for:" > $MAKEFILE
2373 echo "# $MACHINE" >> $MAKEFILE
2374 echo "# This makefile was generated automatically on" >> $MAKEFILE
2375 echo "# $THISDATE" >> $MAKEFILE
2376 echo "# by the command:" >> $MAKEFILE
2377 echo "# $0 $G2ARGS" >> $MAKEFILE
2378 echo "# executed by:" >> $MAKEFILE
2379 echo "# ${THISUSER}@${THISHOST}:${THISCWD}" >> $MAKEFILE
2380
2381 EXE_AD=$EXECUTABLE"_ad"
2382 EXE_FTL=$EXECUTABLE"_ftl"
2383 EXE_SVD=$EXECUTABLE"_svd"
2384
2385 cat >>$MAKEFILE <<EOF
2386 #
2387 # OPTFILE="$OPTFILE"
2388 #
2389 # BUILDDIR : Directory where object files are written
2390 # SOURCEDIRS : Directories containing the source (.F) files
2391 # INCLUDEDIRS : Directories containing the header-source (.h) files
2392 # EXEDIR : Directory where executable that is generated is written
2393 # EXECUTABLE : Full path of executable binary
2394 #
2395 # CPP : C-preprocessor command
2396 # INCLUDES : Directories searched for header files
2397 # DEFINES : Macro definitions for CPP
2398 # MAKEDEPEND : Dependency generator
2399 # KPP : Special preprocessor command (specific to platform)
2400 # KFLAGS : Flags for KPP
2401 # FC : Fortran compiler command
2402 # FFLAGS : Configuration/debugging options for FC
2403 # FOPTIM : Optimization options for FC
2404 # LINK : Command for link editor program
2405 # LIBS : Library flags /or/ additional optimization/debugging flags
2406
2407 ROOTDIR = ${ROOTDIR}
2408 BUILDDIR = ${BUILDDIR}
2409 SOURCEDIRS = ${SOURCEDIRS}
2410 INCLUDEDIRS = ${INCLUDEDIRS}
2411 EXEDIR = ${EXEDIR}
2412 EXECUTABLE = \$(EXEDIR)/${EXECUTABLE}
2413 TOOLSDIR = ${TOOLSDIR}
2414
2415 #eh3 new defines for the adjoint work
2416 AUTODIFF = ${ROOTDIR}/pkg/autodiff
2417 EXE_AD = ${EXE_AD}
2418 EXE_FTL = ${EXE_FTL}
2419 EXE_SVD = ${EXE_SVD}
2420
2421 ENABLED_PACKAGES = ${ENABLED_PACKAGES}
2422 DISABLED_PACKAGES = ${DISABLED_PACKAGES}
2423
2424 # These files are created by Makefile
2425 SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h BUILD_INFO.h
2426 EOF
2427
2428 if test "x$EMBED_SRC" = xt ; then
2429 echo "EMBEDDED_FILES = EMBEDDED_FILES.h" >>$MAKEFILE
2430 else
2431 echo "EMBEDDED_FILES = " >>$MAKEFILE
2432 fi
2433
2434 # Note: figure out some way to add Hyades JAM libraries here
2435 cat >>$MAKEFILE <<EOF
2436 # Unix ln (link)
2437 LN = ${LN}
2438 # C preprocessor
2439 CPP = cat \$< | ${S64} | ${CPP}
2440 # Dependency generator
2441 MAKEDEPEND = ${MAKEDEPEND}
2442 # Special preprocessor (KAP on DECs, FPP on Crays)
2443 KPP = ${KPP}
2444 # Fortran compiler
2445 FC = ${FC}
2446 # Fortran compiler
2447 F90C = ${F90C}
2448 # C compiler
2449 CC = ${CC}
2450 # Link editor
2451 LINK = ${LINK} ${LDADD}
2452
2453 # Defines for CPP
2454 DEFINES = ${DEFINES}
2455 # Includes for CPP
2456 INCLUDES = ${INCLUDES}
2457 # Flags for KPP
2458 KFLAGS1 = ${KFLAGS1}
2459 KFLAGS2 = ${KFLAGS2}
2460 # Optim./debug for FC
2461 FFLAGS = ${FFLAGS}
2462 FOPTIM = ${FOPTIM}
2463 # Optim./debug for FC
2464 F90FLAGS = ${F90FLAGS}
2465 F90OPTIM = ${F90OPTIM}
2466 # Flags for CC
2467 CFLAGS = ${CFLAGS}
2468 # Files that should not be optimized
2469 NOOPTFILES = ${NOOPTFILES}
2470 NOOPTFLAGS = ${NOOPTFLAGS}
2471 # Flags and libraries needed for linking
2472 LIBS = ${LIBS}
2473 # Name of the Mekfile
2474 MAKEFILE=${MAKEFILE}
2475
2476 EOF
2477
2478 cat srclist.inc >> $MAKEFILE
2479 cat csrclist.inc >> $MAKEFILE
2480 cat f90srclist.inc >> $MAKEFILE
2481 cat hlist.inc >> $MAKEFILE
2482 cat ad_flow_files.inc >> $MAKEFILE
2483 echo >> $MAKEFILE
2484 echo 'F77FILES = $(SRCFILES:.F=.'$FS')' >> $MAKEFILE
2485 echo 'F90FILES = $(F90SRCFILES:.F90=.'$FS90')' >> $MAKEFILE
2486 echo 'OBJFILES = $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE
2487 echo >> $MAKEFILE
2488 echo '.SUFFIXES:' >> $MAKEFILE
2489 echo '.SUFFIXES: .o .'$FS' .p .F .c .'$FS90' .F90' >> $MAKEFILE
2490 rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc
2491 rm -f ad_flow_files.inc
2492
2493 cat >>$MAKEFILE <<EOF
2494
2495 all: \$(EXECUTABLE)
2496 \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES) \$(EMBEDDED_FILES)
2497 @echo Creating \$@ ...
2498 \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
2499 depend:
2500 @make links
2501 \$(MAKEDEPEND) -o .$FS \$(DEFINES) \$(INCLUDES) \$(SRCFILES)
2502 \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
2503 -rm -f makedepend.out
2504
2505 lib: libmitgcmuv.a
2506
2507 libmitgcmuv.a: \$(OBJFILES)
2508 ar rcv libmitgcmuv.a \$(OBJFILES)
2509 ar d libmitgcmuv.a main.o
2510
2511 links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
2512
2513 small_f: \$(F77FILES) \$(F90FILES)
2514
2515 output.txt: \$(EXECUTABLE)
2516 @printf 'running ... '
2517 @\$(EXECUTABLE) > \$@
2518
2519 clean:
2520 -rm -rf *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template
2521 -rm -rf *.o
2522 -rm -rf *.$FS
2523 Clean:
2524 @make clean
2525 @make cleanlinks
2526 -rm -f \$(SPECIAL_FILES)
2527 -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log *.bak
2528 CLEAN:
2529 @make Clean
2530 -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
2531 -find \$(EXEDIR) -name "*.data" -exec rm {} \;
2532 -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
2533 -rm -f \$(EXECUTABLE) \$(EXE_AD) *.txt STD* *diagnostics.log datetime
2534 -rm -rf mnc_test_*
2535
2536 #eh3 Makefile: makefile
2537 makefile:
2538 $THIS_SCRIPT $G2ARGS
2539 cleanlinks:
2540 -find . -type l -exec rm {} \;
2541
2542 # Special targets (SPECIAL_FILES) which are create by make
2543 ${PACKAGES_DOT_H}:
2544 @echo Creating \$@ ...
2545 @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@
2546 AD_CONFIG.h:
2547 @echo Creating \$@ ...
2548 @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@
2549 FC_NAMEMANGLE.h:
2550 @echo Creating \$@ ...
2551 echo "$FC_NAMEMANGLE" > \$@
2552
2553 BUILD_INFO.h:
2554 @echo Creating \$@ ...
2555 EOF
2556
2557 test ! "x$THISVER" = x && echo " -echo \"#define THISVER '$THISVER'\" > \$@" >> $MAKEFILE
2558 test ! "x$THISUSER" = x && echo " -echo \"#define THISUSER '$THISUSER'\" >> \$@" >> $MAKEFILE
2559 test ! "x$THISDATE" = x && echo " -echo \"#define THISDATE '$THISDATE'\" >> \$@" >> $MAKEFILE
2560 test ! "x$THISHOST" = x && echo " -echo \"#define THISHOST '$THISHOST'\" >> \$@" >> $MAKEFILE
2561
2562 if test "x$EMBED_SRC" = xt ; then
2563 cat >>$MAKEFILE <<EOF
2564
2565 decode_files.o : EMBEDDED_FILES.h
2566
2567 ## \$(F77FILES)
2568 all_fF.tar.gz : \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(F77FILES) Makefile
2569 @echo Creating \$@ ...
2570 -tar -hcf all_fF.tar \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(F77FILES) Makefile
2571 -rm -f all_fF.tar.gz
2572 -gzip all_fF.tar
2573
2574 EMBEDDED_FILES.h : all_fF.tar.gz
2575 @echo Creating \$@ ...
2576 -\${ROOTDIR}/tools/embed_encode/encode_files EMBEDDED_FILES.h all_fF.tar.gz
2577
2578 EOF
2579 fi
2580
2581 cat >>$MAKEFILE <<EOF
2582
2583 # The normal chain of rules is ( .F - .$FS - .o )
2584
2585 ## This nullifies any default implicit rules concerning these two file types:
2586 ## %.o : %.F
2587
2588 .F.$FS:
2589 \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2590 .$FS.o:
2591 \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
2592 .F90.o:
2593 \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
2594 .c.o:
2595 \$(CC) \$(CFLAGS) \$(DEFINES) \$(INCLUDES) -c \$<
2596
2597 # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain
2598 .F.p:
2599 \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2600 .p.$FS:
2601 \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<
2602
2603 #=========================================
2604 #=== Automatic Differentiation Rules ===
2605
2606 TAMC = ${TAMC}
2607 TAF = ${TAF}
2608
2609 TAF_EXTRA = ${TAF_EXTRA}
2610 TAMC_EXTRA = ${TAMC_EXTRA}
2611
2612 EOF
2613
2614 ad_vars="AD_TAMC_FLAGS AD_TAF_FLAGS"
2615 ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF_FLAGS"
2616 ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"
2617 for i in $ad_vars ; do
2618 name=$i
2619 t1="t2=\$"`echo "$i"`
2620 eval $t1
2621 printf "%-20s = " $name >> $MAKEFILE
2622 echo "$t2" | sed -e 's| \+| |g' >> $MAKEFILE
2623 done
2624
2625 echo " Add the source list for AD code generation"
2626 echo >> $MAKEFILE
2627 printf "AD_FILES = " >> $MAKEFILE
2628 AD_FILES=`cat ad_files`
2629 for i in $AD_FILES ; do
2630 echo " \\" >> $MAKEFILE
2631 printf " $i" >> $MAKEFILE
2632 done
2633 echo >> $MAKEFILE
2634 rm -f ad_files
2635
2636 cat >>$MAKEFILE <<EOF
2637
2638 # ... AD ...
2639 adall: \$(EXE_AD)
2640 adtaf: ad_taf_output.$FS
2641 adtamc: ad_tamc_output.$FS
2642
2643 ad_input_code.$FS: \$(AD_FILES) \$(HEADERFILES)
2644 @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
2645 cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
2646 -rm -f ad_config.template
2647 @make \$(F77FILES)
2648 @make \$(AD_FLOW_FILES)
2649 cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.$FS
2650
2651 ad_taf_output.$FS: ad_input_code.$FS
2652 \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS
2653 cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS
2654
2655 adtafonly:
2656 \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS
2657 cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS
2658
2659 \${EXE_AD}: ad_taf_output.o \$(OBJFILES)
2660 \$(LINK) -o \${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
2661
2662 ad_tamc_output.$FS: ad_input_code.$FS
2663 \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.$FS
2664 cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_tamc_output.$FS
2665
2666 ad_tamc: ad_tamc_output.o \$(OBJFILES)
2667 \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)
2668
2669 adonlyfwd:
2670 patch < \$(TOOLSDIR)/ad_taf_output.f.onlyfwd.diff
2671
2672 adtrick:
2673 patch < \$(TOOLSDIR)/ad_taf_output.f.adtrick.diff
2674
2675 # ... FTL ...
2676 ftlall: ftl_taf
2677 ftltaf: ftl_taf_output.$FS
2678 ftltamc: ftl_tamc_output.$FS
2679
2680 ftl_input_code.$FS: \$(AD_FILES) \$(HEADERFILES)
2681 @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2682 cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2683 -rm -f ftl_config.template
2684 @make \$(F77FILES)
2685 @make \$(AD_FLOW_FILES)
2686 cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.$FS
2687
2688 ftl_taf_output.$FS: ftl_input_code.$FS
2689 \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.$FS
2690 cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.$FS
2691
2692 ftltafonly:
2693 \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.$FS
2694 cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.$FS
2695
2696 ftl_taf: ftl_taf_output.o \$(OBJFILES)
2697 \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)
2698
2699 ftl_tamc_output.$FS: ftl_input_code.$FS
2700 \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.$FS
2701 cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_tamc_output.$FS
2702
2703 ftl_tamc: ftl_tamc_output.o \$(OBJFILES)
2704 \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)
2705
2706
2707 # ... SVD ...
2708 svdtaf: ad_taf_output.$FS ftl_taf_output.$FS
2709 @echo "--->>> Only ran TAF to generate SVD code! <<<---"
2710 @echo "--->>> Do make svdall afterwards to compile. <<<---"
2711 svdall: svd_touch svd_taf
2712
2713 svd_taf: \$(OBJFILES)
2714 \$(LINK) -o mitgcmuv_svd \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o ftl_taf_output.o \$(LIBS)
2715
2716 @echo "--->>> Only COMPILE svd code! <<<---"
2717 @echo "--->>> Assumes you previously <<<---"
2718 @echo "--->>> did make svdtaf <<<---"
2719
2720 svd_touch:
2721 @echo "--->>> Only COMPILE svd code! <<<---"
2722 @echo "--->>> Assumes you previously <<<---"
2723 @echo "--->>> did make svdtaf <<<---"
2724 touch ad_taf_output.$FS ftl_taf_output.$FS
2725 \$(FC) \$(FFLAGS) \$(FOPTIM) -c ad_taf_output.$FS
2726 \$(FC) \$(FFLAGS) \$(FOPTIM) -c ftl_taf_output.$FS
2727 @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2728 cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2729 -rm -f ftl_config.template
2730
2731 #=========================================
2732
2733 EOF
2734
2735 if test "x$EXEHOOK" != x ; then
2736 printf "\nexehook:\n\t%s\n" $EXEHOOK >> $MAKEFILE
2737 fi
2738
2739 echo " Making list of \"exceptions\" that need \".p\" files"
2740 for i in $KPPFILES ; do
2741 base=`echo $i | sed -e 's/\/.*\///g' | sed -e 's/\..*$//g'`
2742 RETVAL=$?
2743 if test "x$RETVAL" != x0 ; then
2744 echo "Error: unable to add file \"$i\" to the exceptions list"
2745 fi
2746 echo "$base.$FS: $base.p" >> $MAKEFILE
2747 done
2748
2749 echo " Making list of NOOPTFILES"
2750 for i in $NOOPTFILES ; do
2751 base=`echo $i | sed -e 's/\/.*\///g' | sed -e 's/\..*$//g'`
2752 RETVAL=$?
2753 if test "x$RETVAL" != x0 ; then
2754 echo "Error: unable to add file \"$i\" to the exceptions list"
2755 fi
2756 echo "$base.o: $base.$FS" >> $MAKEFILE
2757 printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE
2758 done
2759
2760 echo " Add rules for links"
2761 cat srclinks.tmp >> $MAKEFILE
2762 rm -f srclinks.tmp
2763
2764 echo " Adding makedepend marker"
2765 printf "\n\n# DO NOT DELETE\n" >> $MAKEFILE
2766
2767 printf "\n=== Done ===\n"
2768
2769 # Create special header files
2770 $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" $DISABLED_PACKAGES " " "Enabled packages:" $ENABLED_PACKAGES > $PACKAGES_DOT_H".tmp"
2771 if test ! -f $PACKAGES_DOT_H ; then
2772 mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
2773 else
2774 cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H > /dev/null 2>&1
2775 RETVAL=$?
2776 if test "x$RETVAL" = x0 ; then
2777 rm -f $PACKAGES_DOT_H".tmp"
2778 else
2779 mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"
2780 mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
2781 fi
2782 fi
2783 if test ! -f AD_CONFIG.h ; then
2784 $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h
2785 fi
2786
2787
2788 # Write the "state" for future records
2789 if test "x$DUMPSTATE" != xf ; then
2790 printf "" > genmake_state
2791 for i in $gm_state ; do
2792 t1="t2=\$$i"
2793 eval $t1
2794 echo "$i='$t2'" >> genmake_state
2795 done
2796 fi

  ViewVC Help
Powered by ViewVC 1.1.22